Attribute VB_Name = "Serial_Port"
Public Sub SerGet(data$)
' Inputs a line as a string of characters
data$ = ""
c$ = ""
' Eat any Return or Line Feed characters
' left over from end of previous line
SerGetChar c$
start = Timer ' Seconds elapsed since midnight.
'While (((Len(c$) = 0) Or (Asc(c$) > 31)))
'While (Asc(c$) > 31) Or (Timer - start > 115)
'MsgBox "c$=" + Str(Asc(c$))
'While ((c$ <> Chr$(10)) And (c$ <> Chr$(13))) Or (Timer - start > 115)
While ((c$ <> Chr$(10))) Or (Timer - start > 115)
    If (Timer - start) < 0 Then
        start = 0 ' midnight rollover occurred
    End If
    'Loop Until ((Len(c$) = 0) Or (Asc(c$) > 31))
    ' Read characters until Line Feed, Return,
    ' or timeout occurs
    'Do
    If c$ = Chr$(10) Then Exit Sub
    'If c$ = Chr$(13) Then Exit Sub
    'If c$ = "" Then Exit Sub
    data$ = data$ + c$
    SerGetChar c$ ' the next one
Wend
End Sub

Public Sub SerGetNum(X As Variant)
' Inputs a number from the serial port.
' No error checking.
SerGet data$
X = Val(data$)
End Sub

Public Sub SerOpen(portnum%)
' Opens the serial port.
' portnum% = 1 for COM1, 2 for COM2, etc.
' Requires an MSComm control on the main form.
frmMain_PGA308.MSComm1.CommPort = portnum%
frmMain_PGA308.MSComm1.Settings = "9600,N,8,1"
frmMain_PGA308.MSComm1.Handshaking = comRTS
frmMain_PGA308.MSComm1.InputLen = 1 ' read one byte at a time
frmMain_PGA308.MSComm1.PortOpen = True
If Not frmMain_PGA308.MSComm1.PortOpen Then
SerCrash "Cannot open port COM" + Str$(portnum)
End If
' SerMessage "The serial port is open"
End Sub
Public Sub SerOpen1(PortNumber, Bitrate, Parity, Numb_Data_Bits, Numb_Stop_Bits, Flow_Control)

If Not frmMain_PGA308.MSComm1.PortOpen Then
    frmMain_PGA308.MSComm1.CommPort = PortNumber
    'frmMain_PGA308.MSComm1.Settings = Str(Bitrate) + ",N,8,1"
    frmMain_PGA308.MSComm1.Settings = Str(Bitrate) + ", " + Parity + ", " + Str(Numb_Data_Bits) + ", " + Str(Numb_Stop_Bits)
     frmMain_PGA308.MSComm1.Handshaking = Flow_Control
   
    'frmMain_PGA308.MSComm1.Handshaking = comNone
        'MSComm1.RThreshhold = 1
    frmMain_PGA308.MSComm1.InputLen = 1

    frmMain_PGA308.MSComm1.PortOpen = True
End If

If Not frmMain_PGA308.MSComm1.PortOpen Then
SerCrash "Cannot open port COM" + Str$(portnum)
End If

End Sub
Public Sub SerClose()
' Closes the serial port
If frmMain_PGA308.MSComm1.PortOpen = True Then
frmMain_PGA308.MSComm1.PortOpen = False
End If
' SerMessage "The serial port is closed"
End Sub
Public Sub SerPut(data$)
' Transmits a string, followed by CR and LF
frmMain_PGA308.MSComm1.Output = data$ + Chr$(13) + Chr$(10)
'frmMain_PGA308.MSComm1.Output = data$ + Chr$(10)

End Sub
Sub SerCrash(msg$)
' Displays a message and ends the program.
'SerMessage msg$
End ' Forces program to end immediately.
End Sub
Public Sub SerGetChar(c$)
' Retrieves a character from the serial port,
' or times out, returning an empty string,
' if nothing is received for 10 s.

start = Timer ' Seconds elapsed since midnight.
While Timer - start < 10
If (Timer - start) < 0 Then
' midnight rollover occurred
start = 0
End If
If frmMain_PGA308.MSComm1.InBufferCount > 0 Then
c$ = frmMain_PGA308.MSComm1.Input
Exit Sub
End If
Wend
c$ = "" ' timed out, return empty string
End Sub

Public Sub GetWord()
    'pause (1)
    'start = Timer
    'While (frmMain_PGA308.MSComm1.InBufferCount) = 0 And (Timer - start < 2)
    'wait for data
    'pause (0.1)
    'Wend
    
    c$ = ""
    While (frmMain_PGA308.MSComm1.InBufferCount) > 0
        c$ = c$ + (frmMain_PGA308.MSComm1.Input)
        'Exit Sub
    Wend
    
    
    While (frmMain_PGA308.MSComm1.InBufferCount) > 0
        c$ = c$ + (frmMain_PGA308.MSComm1.Input)
        'Exit Sub
    Wend
    
MsgBox c$
End Sub
