Attribute VB_Name = "modPGA308"
Public PGA308Registers(50) As Long
Public RegBitLabel(50) As Variant
'Public RegLegend(50) As String
Public RegBitTips(50) As Variant
Public Reg_ReadOnly(30) As Boolean
'Public PGA_Gain As Double
'Public Decmal209_Register(50) As Double
Public Updating_Controls As Boolean
'Public sw1
'Public Bus_Voltage_Range, ShuntFSR
'Public ReadAddress, WriteAddress
Public MarkRegForWrite(50) As Boolean
Public OldReg(50) As Long
'Public PowerLSB As Double
'Public CurrentLSB As Double
'Public Continous_Read As Boolean
'Public MaxPower As Double
Public m_nRealTimeCounter, real_time As Double
'Public disable_graph As Boolean
Public Log_open As Boolean
'Public new_path As String
'Public old_path As String
'Public what_folder
Public old_row, old_col
Public RegNum As Integer
Public exit_main As Integer
Public MaxReg    'the largest register number, i.e. if MaxReg = 15 then there are 16 registers
Public xxx, Init_Pos ', Mode_fgrid_OTP
Public PGA308_OTP(10, 10)
Public OTP_Bank_Pointer As Integer
Public TestNames(20)
Public Vref_PGA308
Public Vref_int As Double
Global Const MaxRegValue = 65535
Global Const MinRegValue = 0
Public fault_current_enabled As Boolean
Public Vsa As Double
Public Vref_over_under As Double
Public front_end_gain As Double
Public CoarseOffset As Double
Public Output_Amp_Gain As Double
Public Active_frmConfigFaultLogic As Boolean
Public Active_frmOver_Under_Scale_Lim As Boolean
Public Active_frmFaultConfigMonitor As Boolean
Public Active_frmFaultReferences As Boolean
Public Active_frmCorOffsetConf As Boolean
Public Active_frmOneWireConfig As Boolean
Public Vflt As Double
Public Vfault_p As Double
Public Vfault_n As Double
Public Array_Front_End_Gain(32) As Double
Public ArrayOutputGain(7)   As Double
Public Array_CoarseOffset(&H100&)  As Double
Public save_CO_I, save_FEG_I, save_OG_I As Integer
Public Vin_min, Vin_max
Public PGA308_mux, mux_polarity, SignGain_Target
Public read_once
Public AutoSelectOff
Public old_pathx, old_path1, old_path2, old_path3, old_path4
Public Current_Mode
Public Keep_Looping
Public pre_cal As Boolean
Public OneWire_to_Vout As Boolean
Public RAM_OTP_Mode As Integer
Public exit_w_button
Public Engineering_Mode
Public Europe_Mode
Public Vdif_sim, Vdif_range_sim, Vdif_min_sim, Vcm_sim, Vcm_range_sim, Vcm_min_sim
Public simulate_flag
Public abort_prg
'Public V_xtr_ref, R_ref_i_in, R_v_i_in As Double
Public V_xtr_ref, R_ref_i_in    As Double
Public R1_XTR, R2_XTR, C1_XTR 'new feb 12, 08
Global Const pi = 3.141592654
Public c_sign As Double ' fix the change from rev b PGA308 to rev c, c_sign=-1 for rev c
Public UseExternalSupply As Boolean
Public otp_reg As Integer
Public frmhelpwithreg_loaded As Boolean
Public post_cal As Boolean
Public abort_prog As Boolean
Public target_min, target_max As Double
Public pre_post_form_up As Boolean



Public Sub Update_Reg_Help_Rich_Text(reg, otp_reg)
If otp_reg = 1 Then
    reg_help$ = "11"
Else
    reg_help$ = Str(reg)
    reg_help$ = Right$(reg_help$, Len(reg_help$) - 1)
End If
frmHelpWithReg.RichTextBox1.filename = App.Path + "\help\reg" + reg_help$ + ".rtf"
End Sub


'Public m_nRealTimeCounter
Public Sub DoGraph()
   ' Call Read_Ina209
   ' Call Read_INA_Output_Bits
   ' DoEvents
   Dim old_m_nRealTimeCounter
    frmMain_PGA308.Pesgo1.Points = 200

If frmMain_PGA308.ChkCurrentLoopReadback.value = 1 Then
Call Current_Voltage_Mode(1)
Call RunMnemonicCommand("I2C CH2 S 92 ACKS 00 ACKS P") 'put ads1100 in fast mode CONTROL REG=00HEX
Else
Call RunMnemonicCommand("I2C CH2 S 90 ACKS 00 ACKS P") 'put ads1100 in fast mode CONTROL REG=00HEX
End If
Call pause(1)
While Keep_Looping = 1
    NO_LOOPS = 0
    m_nRealTimeCounter = 0
    old_m_nRealTimeCounter = 0
    real_time = Timer
   While ((NO_LOOPS < 199) And (Keep_Looping = 1))
        If frmMain_PGA308.SSTab1.Tab <> 5 Then frmMain_PGA308.SSTab1.Tab = 5 'don't let the user switch tabs
          If ((m_nRealTimeCounter - old_m_nRealTimeCounter) > 0.05) Then
                If frmMain_PGA308.ChkCurrentLoopReadback.value = 1 Then
                   frmMain_PGA308.Pesgo1.YData(0, NO_LOOPS) = Read_I_Loop_fast(1) * 1000
                Else
                  frmMain_PGA308.Pesgo1.YData(0, NO_LOOPS) = Read_ADS1100_1_fast(ads_Conf)
                End If
                 frmMain_PGA308.txtGraphVo = EuroFormat(frmMain_PGA308.Pesgo1.YData(0, NO_LOOPS), "#.###")
             frmMain_PGA308.Pesgo1.XData(0, NO_LOOPS) = m_nRealTimeCounter
             old_m_nRealTimeCounter = m_nRealTimeCounter
             NO_LOOPS = NO_LOOPS + 1
          End If
         frmMain_PGA308.Pesgo1.VertLineAnnotation(0) = m_nRealTimeCounter
         frmMain_PGA308.Pesgo1.VertLineAnnotationType(0) = PELT_MEDIUMSOLID
         frmMain_PGA308.Pesgo1.VertLineAnnotationColor(0) = QBColor(12)
    
       
        '** Update image and force paint **'
         frmMain_PGA308.Pesgo1.PEnarg1 = 0
         frmMain_PGA308.Pesgo1.PEnarg2 = 0
         frmMain_PGA308.Pesgo1.PEactions = 0  '// Calls PEresetimage
        
        DoEvents
     
        '** Increment counter **'
         m_nRealTimeCounter = Timer - real_time
    Wend
Wend
'Call RunMnemonicCommand("I2C CH2 S 90 ACKS 0C ACKS P") 'put ads1100 BACK IN DEFAULT SLOW mode CONTROL REG=00HEX


If frmMain_PGA308.ChkCurrentLoopReadback.value = 1 Then
    Call RunMnemonicCommand("I2C CH2 S 92 ACKS 0C ACKS P") 'put ads1100 BACK IN DEFAULT SLOW mode CONTROL REG=00HEX
    Call Current_Voltage_Mode(0)
Else
    Call RunMnemonicCommand("I2C CH2 S 90 ACKS 0C ACKS P") 'put ads1100 BACK IN DEFAULT SLOW mode CONTROL REG=00HEX
End If

End Sub

Public Function Find_A_Standard_Resistor(R)
Dim Rstd(696)
Dim i, best_resistor, delta_min, best_resistor_i
Rstd(1) = 10
Rstd(2) = 10.2
Rstd(3) = 10.5
Rstd(4) = 10.7
Rstd(5) = 11
Rstd(6) = 11.3
Rstd(7) = 11.5
Rstd(8) = 11.8
Rstd(9) = 12
Rstd(10) = 12.1

Rstd(11) = 12.4
Rstd(12) = 12.7
Rstd(13) = 13
Rstd(14) = 13.3
Rstd(15) = 13.7
Rstd(16) = 14
Rstd(17) = 14.3
Rstd(18) = 14.7
Rstd(19) = 15
Rstd(20) = 15.4

Rstd(21) = 15.8
Rstd(22) = 16
Rstd(23) = 16.2
Rstd(24) = 16.5
Rstd(25) = 16.9
Rstd(26) = 17.4
Rstd(27) = 17.8
Rstd(28) = 18
Rstd(29) = 18.2
Rstd(30) = 18.7

Rstd(31) = 19.1
Rstd(32) = 19.6
Rstd(33) = 20
Rstd(34) = 20.5
Rstd(35) = 21
Rstd(36) = 21.5
Rstd(37) = 22
Rstd(38) = 22.1
Rstd(39) = 22.6
Rstd(40) = 23.2

Rstd(41) = 23.7
Rstd(42) = 24
Rstd(43) = 24.3
Rstd(44) = 24.7
Rstd(45) = 24.9
Rstd(46) = 25.5
Rstd(47) = 26.1
Rstd(48) = 26.7
Rstd(49) = 27
Rstd(50) = 27.4

Rstd(51) = 28
Rstd(52) = 28.7
Rstd(53) = 29.4
Rstd(54) = 30
Rstd(55) = 30.1
Rstd(56) = 30.9
Rstd(57) = 31.6
Rstd(58) = 32.4
Rstd(59) = 33
Rstd(60) = 33.2

Rstd(61) = 34
Rstd(62) = 34.8
Rstd(63) = 35.7
Rstd(64) = 36
Rstd(65) = 36.5
Rstd(66) = 37.4
Rstd(67) = 38.3
Rstd(68) = 39
Rstd(69) = 39.2
Rstd(70) = 40.2

Rstd(71) = 41.2
Rstd(72) = 42.2
Rstd(73) = 43
Rstd(74) = 43.2
Rstd(75) = 44.2
Rstd(76) = 45.3
Rstd(77) = 46.4
Rstd(78) = 47
Rstd(79) = 47.5
Rstd(80) = 48.7

Rstd(81) = 49.9
Rstd(82) = 51
Rstd(83) = 51.1
Rstd(84) = 52.3
Rstd(85) = 53.6
Rstd(86) = 54.9
Rstd(87) = 56
Rstd(88) = 56.2
Rstd(89) = 57.6
Rstd(90) = 59

Rstd(91) = 60.4
Rstd(92) = 61.9
Rstd(93) = 62
Rstd(94) = 63.4
Rstd(95) = 64.9
Rstd(96) = 66.5
Rstd(97) = 68
Rstd(98) = 68.1
Rstd(99) = 69.8
Rstd(100) = 71.5

Rstd(101) = 73.2
Rstd(102) = 75
Rstd(103) = 75.5
Rstd(104) = 76.8
Rstd(105) = 78.7
Rstd(106) = 80.6
Rstd(107) = 82
Rstd(108) = 82.5
Rstd(109) = 84.5
Rstd(110) = 86.6

Rstd(111) = 88.7
Rstd(112) = 90.9
Rstd(113) = 91
Rstd(114) = 93.1
Rstd(115) = 95.3
Rstd(116) = 97.6
'Rstd(127) = 100

For i = 1 To 116
Rstd(116 + i) = Rstd(i) * 10 'to 1k
Next i

For i = 1 To 116
Rstd(232 + i) = Rstd(i) * 100 'to 10k
Next i

For i = 1 To 116
Rstd(348 + i) = Rstd(i) * 1000 'to 100k
Next i

For i = 1 To 116
Rstd(464 + i) = Rstd(i) * 10000 'to 1M
Next i

For i = 1 To 116
Rstd(580 + i) = Rstd(i) * 100000 'to 10M
Next i
best_resistor = 100000000#

For i = 1 To 696
delta_min = Abs(R - Rstd(i))
If delta_min < best_resistor Then
best_resistor = delta_min
best_resistor_i = i
End If
Next i
Find_A_Standard_Resistor = Rstd(best_resistor_i)
End Function
Public Function Find_A_Standard_Cap(CAP)
Dim Cstd(240)
Dim i, best_resistor, delta_min, best_resistor_i
Cstd(1) = 0.000000000001
Cstd(2) = 0.0000000000011
Cstd(3) = 0.0000000000012
Cstd(4) = 0.0000000000013
Cstd(5) = 0.0000000000015
Cstd(6) = 0.0000000000016
Cstd(7) = 0.0000000000018
Cstd(8) = 0.000000000002
Cstd(9) = 0.0000000000022
Cstd(10) = 0.0000000000024
Cstd(11) = 0.0000000000027
Cstd(12) = 0.000000000003
Cstd(13) = 0.0000000000033
Cstd(14) = 0.0000000000036
Cstd(15) = 0.0000000000039
Cstd(16) = 0.0000000000043
Cstd(17) = 0.0000000000047
Cstd(18) = 0.0000000000051
Cstd(19) = 0.0000000000056
Cstd(20) = 0.0000000000062
Cstd(21) = 0.0000000000068
Cstd(22) = 0.0000000000075
Cstd(23) = 0.0000000000082
Cstd(24) = 0.0000000000091


For i = 1 To 24
Cstd(1 * 24 + i) = Cstd(i) * 10 'to 10p
Next i

For i = 1 To 24
Cstd(2 * 24 + i) = Cstd(i) * 100 'to 100p
Next i

For i = 1 To 24
Cstd(3 * 24 + i) = Cstd(i) * 1000 'to 1n
Next i

For i = 1 To 24
Cstd(4 * 24 + i) = Cstd(i) * 10000 'to 10n
Next i

For i = 1 To 24
Cstd(5 * 24 + i) = Cstd(i) * 100000  'to 100n
Next i

For i = 1 To 24
Cstd(6 * 24 + i) = Cstd(i) * 1000000  'to 1u
Next i

For i = 1 To 24
Cstd(7 * 24 + i) = Cstd(i) * 10000000  'to 10u
Next i

For i = 1 To 24
Cstd(8 * 24 + i) = Cstd(i) * 10000000  'to 100u
Next i

For i = 1 To 24
Cstd(9 * 24 + i) = Cstd(i) * 100000000  'to 1000u
Next i

best_cap = 100000000#

For i = 1 To (10 * 24)
delta_min = Abs(CAP - Cstd(i))
If delta_min < best_cap Then
best_cap = delta_min
best_cap_i = i
End If
Next i
Find_A_Standard_Cap = Cstd(best_cap_i)
End Function
Public Sub LoadFromFile_pre_post_only(What_file)
        
Dim tmpPGA308Registers(12)
Dim vs_str As String
Dim vref_str As String
Dim STR_target_max As String
Dim STR_target_min As String

'Dim TmpPGA308Registers(20)
' If What_file = "Full_load" Then
'    Call Load_Path4
' Else
'    MsgBox "What_file is not defined 2"
' End If

frmPre_Post_Cal_Preset.CommonDialog1.DialogTitle = "Load Preset From File "
 Call Load_Paths(What_file) 'Call Load_Path2
    frmPre_Post_Cal_Preset.CommonDialog1.filename = ""
    If old_pathx <> "" Then frmPre_Post_Cal_Preset.CommonDialog1.InitDir = old_pathx
    frmPre_Post_Cal_Preset.CommonDialog1.Filter = "Csv Files (*.csv)|*.csv|"
    frmPre_Post_Cal_Preset.CommonDialog1.Filter = frmPre_Post_Cal_Preset.CommonDialog1.Filter + "All Files (*.*)|*.*"
    frmPre_Post_Cal_Preset.CommonDialog1.ShowOpen
     
    If frmPre_Post_Cal_Preset.CommonDialog1.filename <> "" Then
        Call get_path(frmPre_Post_Cal_Preset.CommonDialog1.filename)
        old_pathx = new_path$
        Call Save_Paths(What_file) 'Call Save_Path2(new_path$)
        Open frmPre_Post_Cal_Preset.CommonDialog1.filename For Input As #101
        
        Input #101, section_no 'aug 19 2007
          
        Input #101, vs_str 'aug 19 2007
            
            vs_str = get_string_after_equal(vs_str)

            vs_str = Euro_US_string_fix(vs_str)
            Vsa = EngineeringVal(vs_str)
            frmMain_PGA308.txtVs = vs_str 'aug 19 2007
            frmPre_Post_Cal_Preset.txtVs2 = vs_str

         Input #101, vref_str 'aug 19 2007
            vref_str = get_string_after_equal(vref_str)

            vref_str = Euro_US_string_fix(vref_str)
            Vref_PGA308 = EngineeringVal(vref_str)
            frmMain_PGA308.txtVref_PGA308 = vref_str 'aug 19 2007
            
         Input #101, strOutput_MODE 'sep 10 2007
         
         strOutput_MODE = get_string_after_equal(strOutput_MODE)
         
         Output_MODE = Val(strOutput_MODE)
         
 
        If Output_MODE = 0 Then
            OneWire_to_Vout = False
            Current_Output = False
            frmMain_PGA308.cmbOutputMode.ListIndex = 0
            frmPre_Post_Cal_Preset.cmbOutputMode.ListIndex = 0
        ElseIf Output_MODE = 1 Then
            OneWire_to_Vout = True
            Current_Output = False
            frmMain_PGA308.cmbOutputMode.ListIndex = 1
            frmPre_Post_Cal_Preset.cmbOutputMode.ListIndex = 1
        Else
            OneWire_to_Vout = False
            Current_Output = True
            frmMain_PGA308.cmbOutputMode.ListIndex = 2
            frmPre_Post_Cal_Preset.cmbOutputMode.ListIndex = 2
        End If

        If OneWire_to_Vout = True Then
            frmOneWireConfig.chkOneToVout.value = 1
            frmMain_PGA308.line_one_wire.Visible = True
        Else
            frmOneWireConfig.chkOneToVout.value = 0
            frmMain_PGA308.line_one_wire.Visible = False
        End If
        
        If Current_Output = True Then
            frmMain_PGA308.chkCurrentOutput = 1
        Else
            frmMain_PGA308.chkCurrentOutput = 0
        End If

        Call frmMain_PGA308.optRAM_Click 'sep 10 2007


         Input #101, STR_target_max
         STR_target_max = get_string_after_equal(STR_target_max)
         target_max = EngineeringVal(STR_target_max)
         txtFullScaleOutput = STR_target_max
         frmPre_Post_Cal_Preset.txtFull_Scale_Output_targ = target_max
         frmMain_PGA308.txtFullScaleOutput = target_max

         Input #101, STR_target_min
         STR_target_min = get_string_after_equal(STR_target_min)
         target_min = EngineeringVal(STR_target_min)
         txtZeroScaleOutput = STR_target_min
         frmPre_Post_Cal_Preset.txtZero_Scale_Output_Targ = target_min
         frmMain_PGA308.txtZeroScaleOutput = target_min

        
        
        
        
        
        For i = 0 To 9
            
            Input #101, reg_str
            
            reg_str = get_string_after_equal(reg_str)
            
            tmpPGA308Registers(i) = Val(reg_str)
           
        Next i
        
        Input #101, res1$
        
        R1_XTR = get_string_after_equal(res1$) 'Jun 5 2009
        
        Input #101, res2$
        
        R2_XTR = get_string_after_equal(res2$) 'Jun 5 2009
        
        Input #101, res_ref$
        
        R_ref_i_in = get_string_after_equal(res_ref$) 'Jun 5 2009
       
        
          '
          ' this section keeps the gain and offset values the same for pre-cal loads.
          '
        
        PGA308Registers(3) = tmpPGA308Registers(3)
        PGA308Registers(4) = tmpPGA308Registers(4)
        PGA308Registers(7) = tmpPGA308Registers(7) And &H80&  'pass OW_DLY mask all other bits
        PGA308Registers(7) = tmpPGA308Registers(7) Or &H50& 'force software lock mode
    Else
        Exit Sub
    End If
    
    Close #101


 Call UpdateRegisterDisplay
 Call Write_All_Reg

End Sub
Public Sub LoadFromFile(What_file)
Dim tmpPGA308Registers(12)
Dim vs_str As String
Dim vref_str As String
Dim STR_target_max As String
Dim STR_target_min As String

'Dim TmpPGA308Registers(20)
' If What_file = "Full_load" Then
'    Call Load_Path4
' Else
'    MsgBox "What_file is not defined 2"
' End If

frmPre_Post_Cal_Preset.CommonDialog1.DialogTitle = "Load Preset From File "
 Call Load_Paths(What_file) 'Call Load_Path2
    frmPre_Post_Cal_Preset.CommonDialog1.filename = ""
    If old_pathx <> "" Then frmPre_Post_Cal_Preset.CommonDialog1.InitDir = old_pathx
    frmPre_Post_Cal_Preset.CommonDialog1.Filter = "Csv Files (*.csv)|*.csv|"
    frmPre_Post_Cal_Preset.CommonDialog1.Filter = frmPre_Post_Cal_Preset.CommonDialog1.Filter + "All Files (*.*)|*.*"
    frmPre_Post_Cal_Preset.CommonDialog1.ShowOpen
     
    If frmPre_Post_Cal_Preset.CommonDialog1.filename <> "" Then
        Call get_path(frmPre_Post_Cal_Preset.CommonDialog1.filename)
        old_pathx = new_path$
        Call Save_Paths(What_file) 'Call Save_Path2(new_path$)
        Open frmPre_Post_Cal_Preset.CommonDialog1.filename For Input As #101
        
        Input #101, section_no 'aug 19 2007
          
        Input #101, vs_str 'aug 19 2007
            
            vs_str = get_string_after_equal(vs_str)

            vs_str = Euro_US_string_fix(vs_str)
            Vsa = EngineeringVal(vs_str)
            frmMain_PGA308.txtVs = vs_str 'aug 19 2007
         Input #101, vref_str 'aug 19 2007
            
            vref_str = get_string_after_equal(vref_str)

            vref_str = Euro_US_string_fix(vref_str)
            Vref_PGA308 = EngineeringVal(vref_str)
            frmMain_PGA308.txtVref_PGA308 = vref_str 'aug 19 2007
            
         Input #101, strOutput_MODE 'sep 10 2007
         
         strOutput_MODE = get_string_after_equal(strOutput_MODE)
         
         Output_MODE = Val(strOutput_MODE)
         
 
        If Output_MODE = 0 Then
            OneWire_to_Vout = False
            Current_Output = False
            frmMain_PGA308.cmbOutputMode.ListIndex = 0
            frmPre_Post_Cal_Preset.cmbOutputMode.ListIndex = 0
        ElseIf Output_MODE = 1 Then
            OneWire_to_Vout = True
            Current_Output = False
            frmMain_PGA308.cmbOutputMode.ListIndex = 1
            frmPre_Post_Cal_Preset.cmbOutputMode.ListIndex = 1
        Else
            OneWire_to_Vout = False
            Current_Output = True
            frmMain_PGA308.cmbOutputMode.ListIndex = 2
            frmPre_Post_Cal_Preset.cmbOutputMode.ListIndex = 2
        End If

        If OneWire_to_Vout = True Then
            frmOneWireConfig.chkOneToVout.value = 1
            frmMain_PGA308.line_one_wire.Visible = True
        Else
            frmOneWireConfig.chkOneToVout.value = 0
            frmMain_PGA308.line_one_wire.Visible = False
        End If
        
        If Current_Output = True Then
            frmMain_PGA308.chkCurrentOutput = 1
        Else
            frmMain_PGA308.chkCurrentOutput = 0
        End If

        Call frmMain_PGA308.optRAM_Click 'sep 10 2007


         Input #101, STR_target_max
         STR_target_max = get_string_after_equal(STR_target_max)
         target_max = EngineeringVal(STR_target_max)
         txtFullScaleOutput = STR_target_max
         frmPre_Post_Cal_Preset.txtFull_Scale_Output_targ = target_max
         frmMain_PGA308.txtFullScaleOutput = target_max

         Input #101, STR_target_min
         STR_target_min = get_string_after_equal(STR_target_min)
         target_min = EngineeringVal(STR_target_min)
         txtZeroScaleOutput = STR_target_min
         frmPre_Post_Cal_Preset.txtZero_Scale_Output_Targ = target_min
         frmMain_PGA308.txtZeroScaleOutput = target_min

         
        
        For i = 0 To 9
            
            Input #101, reg_str
            
            reg_str = get_string_after_equal(reg_str)
            
            PGA308Registers(i) = Val(reg_str)
           
        Next i
        
    Else
        Exit Sub
    End If
    
    Close #101

 Call UpdateRegisterDisplay
 Call Write_All_Reg

End Sub


Public Sub SaveToFile(What_file)
frmPre_Post_Cal_Preset.CommonDialog1.DialogTitle = "Save Preset to File"
Call Load_Paths(What_file) 'Call Load_Path2
    frmPre_Post_Cal_Preset.CommonDialog1.filename = ""
    If old_pathx <> "" Then frmPre_Post_Cal_Preset.CommonDialog1.InitDir = old_pathx
    frmPre_Post_Cal_Preset.CommonDialog1.Filter = "Csv Files (*.csv)|*.csv|"
    frmPre_Post_Cal_Preset.CommonDialog1.Filter = frmPre_Post_Cal_Preset.CommonDialog1.Filter + "All Files (*.*)|*.*"
 frmPre_Post_Cal_Preset.CommonDialog1.ShowSave
     
    If frmPre_Post_Cal_Preset.CommonDialog1.filename <> "" Then
        Call get_path(frmPre_Post_Cal_Preset.CommonDialog1.filename)
        old_pathx = new_path$
        Call Save_Paths(What_file)  'Call Save_Path2(new_path$)
        Open frmPre_Post_Cal_Preset.CommonDialog1.filename For Output As #101
         Print #101, "[PGA308_Config]"
         Print #101, "Vs="; frmMain_PGA308.txtVs 'aug 19 2007
         Print #101, "Vref="; frmMain_PGA308.txtVref_PGA308 'aug 19 2007
         
         If OneWire_to_Vout = True Then 'one to vout
            Output_MODE = 1
         ElseIf OneWire_to_Vout = False And Current_Output = True Then 'current mode
            Output_MODE = 2
         Else 'voltage mode
            Output_MODE = 0
         End If
         
         Print #101, "Output_MODE="; Output_MODE
         Print #101, "Target_Max="; target_max
         Print #101, "Target_Min="; target_min
        For i = 0 To 9
           Print #101, "Reg"; i; "="; PGA308Registers(i)
        Next i
    Else
        Exit Sub
    End If
    
    Close #101





End Sub

Public Function get_string_after_equal(string_in)
Dim test_char, i_equal
test_char = ""
i_equal = 1
While i_equal < Len(string_in) And test_char <> "="
    test_char = Mid$(string_in, i_equal, 1)
    If test_char = "=" Then
    get_string_after_equal = Right$(string_in, Len(string_in) - i_equal)
    Else
    i_equal = i_equal + 1
    End If
Wend
End Function
Public Sub set_RAM_OTP_Modes()
    If RAM_OTP_Mode = 1 Then
         frmMain_PGA308.optOTP.value = True
        frmMain_PGA308.optRAM.value = False
        frmMain_PGA308.otpBank.value = False
        frmMain_PGA308.cmbOTP_Bank_to_RAM.ListIndex = -1

    ElseIf RAM_OTP_Mode = 2 Then
        frmMain_PGA308.optOTP.value = False
        frmMain_PGA308.optRAM.value = True
        frmMain_PGA308.otpBank.value = False
        frmMain_PGA308.cmbOTP_Bank_to_RAM.ListIndex = -1

    ElseIf RAM_OTP_Mode = 3 Then
        frmMain_PGA308.optOTP.value = False
        frmMain_PGA308.optRAM.value = False
        frmMain_PGA308.otpBank.value = True
    End If


If OneWire_to_Vout = True Then
    If RAM_OTP_Mode = 1 Then
        'power up OTP
        frmMain_PGA308.cmbOTP_Bank_to_RAM.Enabled = False
        frmMain_PGA308.cmdReadReg(1).Enabled = True
        frmMain_PGA308.cmdWriteReg(1).Enabled = False
        frmMain_PGA308.cmdReadReg(0).Enabled = True
        frmMain_PGA308.cmdWriteReg(0).Enabled = False
    ElseIf RAM_OTP_Mode = 2 Then
        'run out of RAM
        frmMain_PGA308.cmbOTP_Bank_to_RAM.Enabled = False
        frmMain_PGA308.cmdReadReg(1).Enabled = False
        frmMain_PGA308.cmdWriteReg(1).Enabled = True
        frmMain_PGA308.cmdReadReg(0).Enabled = False
        frmMain_PGA308.cmdWriteReg(0).Enabled = True
    ElseIf RAM_OTP_Mode = 3 Then
        'run out of OTP Bank
        frmMain_PGA308.cmbOTP_Bank_to_RAM.Enabled = True
        frmMain_PGA308.cmdReadReg(1).Enabled = False
        frmMain_PGA308.cmdWriteReg(1).Enabled = False
        frmMain_PGA308.cmdReadReg(0).Enabled = False
        frmMain_PGA308.cmdWriteReg(0).Enabled = False
    Else
   
    End If
Else
    If RAM_OTP_Mode = 1 Then
        'power up OTP
        frmMain_PGA308.cmbOTP_Bank_to_RAM.Enabled = False
        frmMain_PGA308.cmdReadReg(1).Enabled = True
        frmMain_PGA308.cmdWriteReg(1).Enabled = False
        frmMain_PGA308.cmdReadReg(0).Enabled = True
        frmMain_PGA308.cmdWriteReg(0).Enabled = False
     ElseIf RAM_OTP_Mode = 2 Then
        'run out of RAM
        frmMain_PGA308.cmbOTP_Bank_to_RAM.Enabled = False
        frmMain_PGA308.cmdReadReg(1).Enabled = True
        frmMain_PGA308.cmdWriteReg(1).Enabled = True
        frmMain_PGA308.cmdReadReg(0).Enabled = True
        frmMain_PGA308.cmdWriteReg(0).Enabled = True
    ElseIf RAM_OTP_Mode = 3 Then
        'run out of OTP Bank
        frmMain_PGA308.cmbOTP_Bank_to_RAM.Enabled = True
        frmMain_PGA308.cmdReadReg(1).Enabled = True
        frmMain_PGA308.cmdWriteReg(1).Enabled = False
        frmMain_PGA308.cmdReadReg(0).Enabled = True
        frmMain_PGA308.cmdWriteReg(0).Enabled = False
    Else
   
    End If
End If
With frmMain_PGA308.gridReg
    For i = 0 To MaxReg
        .TextMatrix(i + 1, 1) = TestNames(i + 1) 'reset reg edited indicater
    Next i
End With

End Sub
Public Sub config_chart1()
'117  Scientific Graph showing real-time 3
    
    '** Chart fills 100 points and once 100 points have
    '** been passed, old data is over-written as more
    '** data is passed to chart.
        frmMain_PGA308.Pesgo1.PlottingMethod = 0 'GPM_POINTSPLUSLINE'was
    frmMain_PGA308.Pesgo1.ShowAnnotations = True

    frmMain_PGA308.Pesgo1.Subsets = 1
    frmMain_PGA308.Pesgo1.Points = 100
    frmMain_PGA308.Pesgo1.SubsetLabels(0) = "PGA308 Output Voltage"
    'frmMain_PGA308.Pesgo1.SubsetLabels(1) = "Peak Bus Voltage"
     'frmMain_PGA308.Pesgo1.SubsetColors(1) = &HFF&
   '  frmMain_PGA308.Pesgo1.GraphAnnotationType(1) = PEGAT_SMALLCROSS
    'frmMain_PGA308.Pesgo1.GraphAnnotationType(0) = PEPT_SQUARESOLID
    
    '** Set Manual Y scale **'
    frmMain_PGA308.Pesgo1.ManualScaleControlY = PEMSC_MINMAX
    frmMain_PGA308.Pesgo1.ManualMinY = 0 'was 1
    frmMain_PGA308.Pesgo1.ManualMaxY = 5 'was 100
 
    '** Set Manual X scale **'
    frmMain_PGA308.Pesgo1.ManualScaleControlX = PEMSC_MINMAX
    frmMain_PGA308.Pesgo1.ManualMinX = 0
    frmMain_PGA308.Pesgo1.ManualMaxX = 10
 
    '** Show Annotations **'
    frmMain_PGA308.Pesgo1.ShowAnnotations = True
 
    '** Clear out default data **'
    frmMain_PGA308.Pesgo1.XData(0, 0) = 0
    frmMain_PGA308.Pesgo1.XData(0, 1) = 0
    frmMain_PGA308.Pesgo1.XData(0, 2) = 0
    frmMain_PGA308.Pesgo1.XData(0, 3) = 0
    frmMain_PGA308.Pesgo1.YData(0, 0) = 0
    frmMain_PGA308.Pesgo1.YData(0, 1) = 0
    frmMain_PGA308.Pesgo1.YData(0, 2) = 0
    frmMain_PGA308.Pesgo1.YData(0, 3) = 0

    '** Set various properties **'
    frmMain_PGA308.Pesgo1.MainTitle = "PGA308 Output Voltage vs Time"
    frmMain_PGA308.Pesgo1.SubTitle = ""
    frmMain_PGA308.Pesgo1.NoRandomPointsToExport = True
    frmMain_PGA308.Pesgo1.FocalRect = False
    frmMain_PGA308.Pesgo1.AllowBar = False
    frmMain_PGA308.Pesgo1.AllowPopup = False
    frmMain_PGA308.Pesgo1.DeskColor = RGB(192, 192, 192)

    frmMain_PGA308.Pesgo1.PEactions = 0
    
    frmMain_PGA308.Pesgo1.XAxisLabel = "Time (sec)"
    frmMain_PGA308.Pesgo1.YAxisLabel = "Voltage (V)"
     frmMain_PGA308.Pesgo1.MarkDataPoints = True
    'frmMain_PGA308.Pesgo1.MinimumPointSize = PEMPS_LARGE
    frmMain_PGA308.Pesgo1.FontSize = PEFS_LARGE
      
  
End Sub


Public Sub read_all()
Call Read_All_Reg
    frmMain_PGA308.ProgressBar1.value = 0
If RAM_OTP_Mode = 1 Or OneWire_to_Vout = True Then
    Call pause(0.5)
    frmMain_PGA308.ProgressBar1.value = 10
    
    Call pause(0.5)
    frmMain_PGA308.ProgressBar1.value = 20
    
    Call pause(0.5)
    frmMain_PGA308.ProgressBar1.value = 30
End If

frmMain_PGA308.txtVin_dif_meas = DisplayEngineering(Read_ADS1100_2(ads_Conf))  ' jul 14, 08
frmMain_PGA308.ProgressBar1.value = 25

frmMain_PGA308.txtVout = EuroFormat(Read_ADS1100_1(ads_Conf), "0.0###")
frmMain_PGA308.ProgressBar1.value = 50

Call RunMnemonicCommand("CMD MEAS ")
frmMain_PGA308.txtDoutVclamp = Hex(ReadData(0) And &H1&)
frmMain_PGA308.txtCalcOut = ((((mux_polarity * EngineeringVal(frmMain_PGA308.txtVin_dif_meas) - CoarseOffset / 1000)) * front_end_gain) + EngineeringVal(frmMain_PGA308.txtFineOffset)) * EngineeringVal(frmMain_PGA308.txtFineGain.Text) * Output_Amp_Gain
frmMain_PGA308.ProgressBar1.value = 100
frmMain_PGA308.ProgressBar1.value = 0

End Sub
Public Sub Current_Voltage_Mode(C_Mode)
If C_Mode = 1 Then
    Call RunMnemonicCommand("CMD EN_ADS OFF") 'ADDED THIS FEB 22, 07
    Call ADS_MUX2("OPEN", "GND")
    Call RunMnemonicCommand("CMD ILOOP ON")
Else
    Call ADS_MUX2("OPEN", "OPEN") 'ADDED THIS FEB 22, 07
    Call RunMnemonicCommand("CMD ILOOP OFF")
    Call RunMnemonicCommand("CMD EN_ADS ON") 'ADDED THIS FEB 22, 07
End If

End Sub
Public Sub Read_Controls_frmConfigFaultLogic()
If Updating_Controls = True Then Exit Sub

    '
    'chkFaultExteranlEnable
    '
     If frmConfigFaultLogic.chkFaultExteranlEnable.value = 1 Then
         PGA308Registers(3) = PGA308Registers(3) Or (&H400&)
     Else
         PGA308Registers(3) = PGA308Registers(3) And (&HFBFF&)
     End If
    '
    'chkFaultInternallEnable
    '
     If frmConfigFaultLogic.chkFaultInternallEnable.value = 1 Then
         PGA308Registers(3) = PGA308Registers(3) Or (&H200&)
     Else
         PGA308Registers(3) = PGA308Registers(3) And (&HFDFF&)
     End If
    '
    'optExtPol_Vout_H optExtPol_Vout_L
    '
    If frmConfigFaultLogic.optExtPol_Vout_H = True Then
        PGA308Registers(3) = PGA308Registers(3) Or (&H100&)
    Else
        PGA308Registers(3) = PGA308Registers(3) And (&HFEFF&)
    End If
    '
    'optIntPol_Vout_H optIntPol_Vout_L
    '
    If frmConfigFaultLogic.optIntPol_Vout_H = True Then
        PGA308Registers(3) = PGA308Registers(3) Or (&H80&)
    Else
        PGA308Registers(3) = PGA308Registers(3) And (&HFF7F&)
    End If

Call UpdateRegisterDisplay

End Sub
Public Sub Read_All_Reg()
If OneWire_to_Vout = True Then
    If RAM_OTP_Mode = 1 Then
        Call one_wire_to_Vout_read
    Else
        MsgBox "Can not read in this mode (1w to vout / RAM)"
    End If
Else
     If RAM_OTP_Mode = 1 Then
         Call one_wire_to_Vout_read 'if using POR OTP cycle power to prevent "communication lockup" i.e. if POR OTP has OWD=1
     Else
        Call Read_All_Reg_Normal
     End If
End If
End Sub

Public Sub Read_Controls_frmOver_Under_Scale_Lim()
If Updating_Controls = True Then Exit Sub

    '
    ' chkOverUnderEn
    '
    If frmOver_Under_Scale_Lim.chkOverUnderEn.value = 1 Then
        PGA308Registers(3) = PGA308Registers(3) Or (&H40&)
        frmMain_PGA308.cmbUnderScale.Enabled = True
        frmMain_PGA308.cmbOverScale.Enabled = True
    Else
        PGA308Registers(3) = PGA308Registers(3) And (&HFFBF&)
        frmMain_PGA308.cmbUnderScale.Enabled = False
        frmMain_PGA308.cmbOverScale.Enabled = False
    End If

    '
    ' optOv_Ud_ref_Vref
    '
    If frmOver_Under_Scale_Lim.optOv_Ud_ref_Vsa = True Then
        PGA308Registers(3) = PGA308Registers(3) Or (&H2000&)
        Vref_over_under = Vsa
    Else
        PGA308Registers(3) = PGA308Registers(3) And (&HDFFF&)
        Vref_over_under = Vref_PGA308
    End If

Call UpdateRegisterDisplay

End Sub


Public Sub set_sim_slider()
'Vdif_sim = EngineeringVal(frmMain_PGA308.slider_vdif_sim) / 1000 * Vdif_range_sim + Vdif_min_sim
'Vcm_sim = EngineeringVal(frmMain_PGA308.slider_vcm_sim) / 1000 * Vcm_range_sim + Vcm_min_sim

frmMain_PGA308.lbl_sim(7) = Vcm_min_sim
frmMain_PGA308.lbl_sim(8) = Vcm_range_sim + Vcm_min_sim
frmMain_PGA308.lbl_sim(5) = DisplayEngineering(Vdif_min_sim)
frmMain_PGA308.lbl_sim(6) = DisplayEngineering(Vdif_range_sim + Vdif_min_sim)



Vcm_sim = EngineeringVal(frmMain_PGA308.txtSIM(10))
If Vcm_sim < Vcm_min_sim Then
    Vcm_sim = Vcm_min_sim
End If
If Vcm_sim > (Vcm_range_sim + Vcm_min_sim) Then
    Vcm_sim = Vcm_range_sim + Vcm_min_sim
End If

Vdif_sim = EngineeringVal(frmMain_PGA308.txtSIM(11))

If Vdif_sim < Vdif_min_sim Then
    Vdif_sim = Vdif_min_sim
End If
If Vdif_sim > (Vdif_range_sim + Vdif_min_sim) Then
    Vdif_sim = (Vdif_range_sim + Vdif_min_sim)
End If


frmMain_PGA308.slider_vdif_sim = 1000 * (Vdif_sim - Vdif_min_sim) / Vdif_range_sim
frmMain_PGA308.slider_vcm_sim = 1000 * (Vcm_sim - Vcm_min_sim) / Vcm_range_sim

End Sub

Public Sub Write_All_Reg()
If OneWire_to_Vout = True Then
    Call one_to_Vout_write
Else
    Call Write_All_Reg_Norm
End If
End Sub
Public Sub one_to_Vout_write()
'Call RunMnemonicCommand("CMD EN_ONE ON") 'EN_ONE ON (or OFF)

If (PGA308Registers(4) And &H8000&) <> &H8000& Then
    MsgBox "You must set the OWD=1 (reg 4) to avoid shoot-through current when the One-Wire is tied to Vout." + vbCrLf + "The PGA308 software will set this automatically."
    PGA308Registers(4) = PGA308Registers(4) Or &H8000& ' force owd = 1 on reg 4, bit 8 to prevent shoot through current
End If
        Call RunMnemonicCommand("CMD OFF")
        Call pause(0.1)
        Call RunMnemonicCommand("CMD WAKE_UP_ONE") 'done
 
 
frmMain_PGA308.ProgressBar1.value = 10
 
For i = 0 To 4
        REG_MSB = Shift_Right((&HFF00&) And (PGA308Registers(i)), 8)
        REG_LSB = (&HFF&) And (PGA308Registers(i))
        Call RunMnemonicCommand("ONE 55 " + Hex(i) + " " + Hex(REG_LSB) + " " + Hex(REG_MSB)) 'write
        If ReadData(30) <> 0 Then
            MsgBox "timeout on One-Wire transaction"
        End If
        frmMain_PGA308.ProgressBar1.value = 15 + i * 5

Next i



    Call RunMnemonicCommand("ONE 55 " + Hex(6 + &H80&) + " R R ") ' read Internaly calculated checksum reg
    PGA308Registers(6) = Shift_Left(ReadData(1), 8) + ReadData(0)
    REG_MSB = ReadData(1)
    REG_LSB = ReadData(0)
    Call RunMnemonicCommand("ONE 55 " + Hex(5) + " " + Hex(REG_LSB) + " " + Hex(REG_MSB))   'write checksum Reg
    Call RunMnemonicCommand("ONE 55 " + Hex(5 + &H80&) + " R R ") ' read Internaly calculated checksum reg
    PGA308Registers(5) = Shift_Left(ReadData(1), 8) + ReadData(0)
   'MsgBox "PGA308Registers(5)=" + Hex(PGA308Registers(5)) + vbCrLf + "PGA308Registers(6)=" + Hex(PGA308Registers(6))

'
' at some point we may want to write into OENC reg reg 8
' reg 7, 9, and 10 are not needed for 1w tied to vout
'
        frmMain_PGA308.ProgressBar1.value = 40

For i = 0 To &HF&
    Call RunMnemonicCommand("ONE 55 " + Hex(i + &H80&) + " R R ") ' read Internaly calculated checksum reg
        If ReadData(30) <> 0 Then
            MsgBox "timeout on One-Wire transaction" + vbCrLf + "loop=" + Str(i)
        End If
        PGA308Registers(i) = Shift_Left(ReadData(1), 8) + ReadData(0)
                frmMain_PGA308.ProgressBar1.value = 45 + i * 2
    MarkRegForWrite(i) = False 'aug 20 2007

Next i


With frmMain_PGA308.gridReg
    For i = 0 To MaxReg
        .TextMatrix(i + 1, 1) = TestNames(i + 1) 'reset reg edited indicater
    Next i
End With

With frmMain_PGA308.fgrid_RAM
    For i = 0 To 5
        .TextMatrix(i + 1, 1) = Hex(PGA308Registers(i))
    Next i
End With
                frmMain_PGA308.ProgressBar1.value = 0



    If OneWire_to_Vout = True Then
        Call RunMnemonicCommand("CMD EN_ONE OFF ") 'EN_ONE ON (or OFF)
    End If

End Sub
Public Sub one_to_vout_write_OTP()
If (PGA308Registers(4) And &H8000) <> &H8000 Then
    MsgBox "You must set the OWD=1 (reg 4) to avoid shoot-through current when the One-Wire is tied to Vout." + vbCrLf + "The PGA308 software will set this automatically."
    PGA308Registers(4) = PGA308Registers(4) Or &H8000 ' force owd = 1 on reg 4, bit 8 to prevent shoot through current
End If

'If ((PGA308Registers(7) And &H50&) <> &H50&) Then
'    MsgBox "'Software lock mode' is not set to 'Run out of RAM' mode.  (Register 7)"
'    Exit Sub
'End If
If ((PGA308Registers(10) And &H8000&) <> &H8000&) Then
    MsgBox "OTP is not 'Enabled for Write'.  (Register 10, Bit 15, OTP_EN)" + vbCrLf + "The PGA308 software will set this automatically."
    PGA308Registers(10) = PGA308Registers(10) Or &H8000&
End If
If (PGA308Registers(5) <> PGA308Registers(6)) Then
    MsgBox "The check sum you are using is not correct.  Copy register 6 into register 5 for correct check sum." + vbCrLf + "The PGA308 software will set this automatically."
    Exit Sub
End If


    Call RunMnemonicCommand("CMD OFF")
    Call pause(0.1)
    Call RunMnemonicCommand("CMD WAKE_UP_ONE") 'done
 
 


'
' write OTP_EN =1
'
        REG_MSB = Shift_Right((&HFF00&) And (PGA308Registers(10)), 8)
        REG_LSB = (&HFF&) And (PGA308Registers(10))
        Call RunMnemonicCommand("ONE 55 " + Hex(10) + " " + Hex(REG_LSB) + " " + Hex(REG_MSB)) 'write
        If ReadData(30) <> 0 Then
            MsgBox "timeout on One-Wire transaction"
        End If
'
' DONE write OTP_EN =1
'

 
Bank_No = OTP_Bank_Pointer
For Reg_No = 0 To 5
    Bank_Pointer = Shift_Left(Bank_No, 3)
    Read_notWrite = &H0&  'read = &H80&, write = &H00&
    Bank_notSoftware = &H40& 'B/notR = &H40& for bank, B/notR = &H00& for software
    OTP_Address = Bank_notSoftware Or Read_notWrite Or Bank_Pointer Or Reg_No
    REG_MSB = Shift_Right((&HFF00&) And (PGA308Registers(Reg_No)), 8)
    REG_LSB = (&HFF&) And (PGA308Registers(Reg_No))
    Call RunMnemonicCommand("ONE 55 " + Hex(OTP_Address) + " " + Hex(REG_LSB) + " " + Hex(REG_MSB)) 'set pointer
Next Reg_No

    If OneWire_to_Vout = True Then
        Call RunMnemonicCommand("CMD EN_ONE OFF ") 'EN_ONE ON (or OFF)
    End If

    'Call read_all_OTP_Normal

End Sub
Public Sub one_to_vout_write_OTP_6_7()
Dim chk_flag As Boolean
'If (PGA308Registers(4) And &H8000) <> &H8000 Then
'    MsgBox "You must set the OWD=1 (reg 4) to avoid shoot-through current when the One-Wire is tied to Vout." + vbCrLf + "The PGA308 software will set this automatically."
'    PGA308Registers(4) = PGA308Registers(4) Or &H8000 ' force owd = 1 on reg 4, bit 8 to prevent shoot through current
'End If

'If ((PGA308Registers(7) And &H50&) <> &H50&) Then
'    MsgBox "'Software lock mode' is not set to 'Run out of RAM' mode.  (Register 7)"
'    Exit Sub
'End If
If ((PGA308Registers(10) And &H8000&) <> &H8000&) Then
    MsgBox "OTP is not 'Enabled for Write'.  (Register 10, Bit 15, OTP_EN)" + vbCrLf + "The PGA308 software will set this automatically."
    PGA308Registers(10) = PGA308Registers(10) Or &H8000&
End If
If (PGA308Registers(5) <> PGA308Registers(6)) Then
    MsgBox "The check sum you are using is not correct.  Copy register 6 into register 5 for correct check sum." + vbCrLf + "The PGA308 software will set this automatically."
    Exit Sub
End If


    Call RunMnemonicCommand("CMD OFF")
    Call pause(0.1)
    Call RunMnemonicCommand("CMD WAKE_UP_ONE") 'done
 
 


'
' write OTP_EN =1
'
        REG_MSB = Shift_Right((&HFF00&) And (PGA308Registers(10)), 8)
        REG_LSB = (&HFF&) And (PGA308Registers(10))
        Call RunMnemonicCommand("ONE 55 " + Hex(10) + " " + Hex(REG_LSB) + " " + Hex(REG_MSB)) 'write
        If ReadData(30) <> 0 Then
            MsgBox "timeout on One-Wire transaction"
        End If
'
' DONE write OTP_EN =1
'

 
Bank_No = OTP_Bank_Pointer
For Reg_No = 6 To 7
    Bank_Pointer = Shift_Left(Bank_No, 3)
    Read_notWrite = &H0&  'read = &H80&, write = &H00&
    Bank_notSoftware = &H40& 'B/notR = &H40& for bank, B/notR = &H00& for software
    OTP_Address = Bank_notSoftware Or Read_notWrite Or Bank_Pointer Or Reg_No
     X = convert_string_to_hex16(frmMain_PGA308.txtUSER(Reg_No - 6), chk_flag)
     frmMain_PGA308.txtUSER(Reg_No - 6).Text = Hex(X)
    If chk_flag = False Then
        REG_MSB = Shift_Right((&HFF00&) And (X), 8)
        REG_LSB = (&HFF&) And (X)
        Call RunMnemonicCommand("ONE 55 " + Hex(OTP_Address) + " " + Hex(REG_LSB) + " " + Hex(REG_MSB)) 'set pointer
    End If
Next Reg_No

    'Call read_all_OTP_Normal

    If OneWire_to_Vout = True Then
        Call RunMnemonicCommand("CMD EN_ONE OFF ") 'EN_ONE ON (or OFF)
    End If






End Sub

Public Sub Write_All_Reg_Norm()
    frmMain_PGA308.ProgressBar1.value = 0
For i = 0 To MaxReg
       'If MarkRegForWrite(i) = True Then 'aug 20 2007
        REG_MSB = Shift_Right((&HFF00&) And (PGA308Registers(i)), 8)
        REG_LSB = (&HFF&) And (PGA308Registers(i))
        Call RunMnemonicCommand("ONE 55 " + Hex(i) + " " + Hex(REG_LSB) + " " + Hex(REG_MSB))
       'End If 'aug 20 2007
    frmMain_PGA308.ProgressBar1.value = frmMain_PGA308.ProgressBar1.value + 100 / (MaxReg + 2)
    MarkRegForWrite(i) = False 'aug 20 2007

Next i
With frmMain_PGA308.gridReg
    For i = 0 To MaxReg
        .TextMatrix(i + 1, 1) = TestNames(i + 1) 'reset reg edited indicater
    Next i
End With

frmMain_PGA308.ProgressBar1.value = 0

End Sub

Public Sub Write_OTP()
If ((PGA308Registers(7) And &H50&) <> &H50&) Then
    MsgBox "'Software lock mode' is not set to 'Run out of RAM' mode.  (Register 7)"
    Exit Sub
End If
If ((PGA308Registers(10) And &H8000&) <> &H8000&) Then
    MsgBox "OTP is not 'Enabled for Write'.  (Register 10, Bit 15, OTP_EN)"
    Exit Sub
End If
If (PGA308Registers(5) <> PGA308Registers(6)) Then
    MsgBox "The check sum you are using is not correct.  Copy register 6 into register 5 for correct check sum."
    Exit Sub
End If
 
Bank_No = OTP_Bank_Pointer
For Reg_No = 0 To 5
    Bank_Pointer = Shift_Left(Bank_No, 3)
    Read_notWrite = &H0&  'read = &H80&, write = &H00&
    Bank_notSoftware = &H40& 'B/notR = &H40& for bank, B/notR = &H00& for software
    OTP_Address = Bank_notSoftware Or Read_notWrite Or Bank_Pointer Or Reg_No
    REG_MSB = Shift_Right((&HFF00&) And (PGA308Registers(Reg_No)), 8)
    REG_LSB = (&HFF&) And (PGA308Registers(Reg_No))
    Call RunMnemonicCommand("ONE 55 " + Hex(OTP_Address) + " " + Hex(REG_LSB) + " " + Hex(REG_MSB)) 'set pointer
Next Reg_No

    Call read_all_OTP_Normal


End Sub


Public Sub one_wire_to_Vout_read()
         frmMain_PGA308.ProgressBar1.value = 5
        Call RunMnemonicCommand("CMD OFF")
        Call pause(0.1)
        Call RunMnemonicCommand("CMD WAKE_UP_ONE") 'done
        frmMain_PGA308.ProgressBar1.value = 10
        

For i = 0 To &HF&
    Call RunMnemonicCommand("ONE 55 " + Hex(i + &H80&) + " R R ") ' read Internaly calculated checksum reg
        If ReadData(30) <> 0 Then
            MsgBox "timeout on One-Wire transaction"
        End If
        PGA308Registers(i) = Shift_Left(ReadData(1), 8) + ReadData(0)
        frmMain_PGA308.ProgressBar1.value = 10 + i * 2
        MarkRegForWrite(i) = False

Next i


Call UpdateRegisterDisplay

With frmMain_PGA308.gridReg
    For i = 0 To MaxReg
        .TextMatrix(i + 1, 1) = TestNames(i + 1) 'reset reg edited indicater
    Next i
End With

With frmMain_PGA308.fgrid_RAM
    For i = 0 To 5
        .TextMatrix(i + 1, 1) = Hex(PGA308Registers(i))
    Next i
End With
        frmMain_PGA308.ProgressBar1.value = 0
        
        
    If OneWire_to_Vout = True Then
        Call RunMnemonicCommand("CMD EN_ONE OFF ") 'EN_ONE ON (or OFF)
    End If
        

End Sub
Public Sub read_all_OTP_Normal()
For Bank_No = 0 To 7
    If DebugOn = 2 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "OTP bank read = " + Str(Bank_No) + vbCrLf
    For Reg_No = 0 To 7
        Bank_Pointer = Shift_Left(Bank_No, 3)
        Read_notWrite = &H80& 'read = &H80&, write = &H00&
        Bank_notSoftware = &H40& 'B/notR = &H40& for bank, B/notR = &H00& for software
        OTP_Address = Bank_notSoftware Or Read_notWrite Or Bank_Pointer Or Reg_No
        Call RunMnemonicCommand("ONE 55 " + Hex(OTP_Address) + " R R ")
        'was PGA308_OTP(REG, Bank) = Shift_Left(ReadData(1), 8) + ReadData(0)
        PGA308_OTP(Reg_No, Bank_No) = Shift_Left(ReadData(1), 8) + ReadData(0)
        'was frmMain_PGA308.fgrid_OTP.TextMatrix(Reg_No + 1, Bank_No + 1) = Hex(PGA308_OTP(REG, Bank))
        frmMain_PGA308.fgrid_OTP.TextMatrix(Reg_No + 1, Bank_No + 1) = Hex(PGA308_OTP(Reg_No, Bank_No))
    Next Reg_No
    DoEvents
    frmMain_PGA308.ProgressBar1.value = Bank_No * 100 / 7

Next Bank_No
frmMain_PGA308.ProgressBar1.value = 0

Bank_No = 0
For Reg_No = 0 To 7
    ''was frmMain_PGA308.txtRegBank0(Reg_No).Text = Hex(PGA308_OTP(REG, Bank))
    frmMain_PGA308.txtRegBank0(Reg_No).Text = Hex(PGA308_OTP(Reg_No, Bank_No))
Next Reg_No
DoEvents


End Sub
Public Sub one_to_vout_read_all_OTP()
    Call RunMnemonicCommand("CMD OFF")
    Call pause(0.1)
    Call RunMnemonicCommand("CMD WAKE_UP_ONE") 'done
 
 

For Bank_No = 0 To 7
    If DebugOn = 2 Then frmDebugUSB.txtUSB_Debug.Text = frmDebugUSB.txtUSB_Debug.Text + "OTP bank read = " + Str(Bank_No) + vbCrLf
    For Reg_No = 0 To 7
        Bank_Pointer = Shift_Left(Bank_No, 3)
        Read_notWrite = &H80& 'read = &H80&, write = &H00&
        Bank_notSoftware = &H40& 'B/notR = &H40& for bank, B/notR = &H00& for software
        OTP_Address = Bank_notSoftware Or Read_notWrite Or Bank_Pointer Or Reg_No
        Call RunMnemonicCommand("ONE 55 " + Hex(OTP_Address) + " R R ")
        'was PGA308_OTP(REG, Bank) = Shift_Left(ReadData(1), 8) + ReadData(0)
        PGA308_OTP(Reg_No, Bank_No) = Shift_Left(ReadData(1), 8) + ReadData(0)
        'was frmMain_PGA308.fgrid_OTP.TextMatrix(Reg_No + 1, Bank_No + 1) = Hex(PGA308_OTP(REG, Bank))
        frmMain_PGA308.fgrid_OTP.TextMatrix(Reg_No + 1, Bank_No + 1) = Hex(PGA308_OTP(Reg_No, Bank_No))
    Next Reg_No
    DoEvents
    frmMain_PGA308.ProgressBar1.value = Bank_No * 100 / 7

Next Bank_No
'    frmMain_PGA308.ProgressBar1.value = i * 100 / MaxReg

Bank_No = 0
For Reg_No = 0 To 7
    ''was frmMain_PGA308.txtRegBank0(Reg_No).Text = Hex(PGA308_OTP(REG, Bank))
    frmMain_PGA308.txtRegBank0(Reg_No).Text = Hex(PGA308_OTP(Reg_No, Bank_No))
    frmMain_PGA308.ProgressBar1.value = Reg_No * 100 / 7
Next Reg_No
DoEvents

    If OneWire_to_Vout = True Then
        Call RunMnemonicCommand("CMD EN_ONE OFF ") 'EN_ONE ON (or OFF)
    End If
    frmMain_PGA308.ProgressBar1.value = 0

End Sub
Public Sub read_all_OTP()
 If OneWire_to_Vout = True Then
    If RAM_OTP_Mode = 1 Then
    Call one_to_vout_read_all_OTP
    Else
    ANSW$ = MsgBox("Power must be cycled to read OTP." + vbCrLf + "This action will reset RAM!." + vbCrLf + "Do you want to proceed?", vbYesNo)
    If ANSW$ = vbYes Then
        Call one_to_vout_read_all_OTP
    End If
    End If
 Else
    If RAM_OTP_Mode = 1 Then
        Call one_to_vout_read_all_OTP
    Else
        Call read_all_OTP_Normal
    End If
   
 End If

End Sub
Public Sub disable_all_controls()
frmMain_PGA308.cmdWriteReg(0).Enabled = False
frmMain_PGA308.cmdWriteReg(1).Enabled = False
frmMain_PGA308.cmdFaultLogic.Enabled = False
frmMain_PGA308.cmdFaultRef.Enabled = False
frmMain_PGA308.cmdFaultConfig.Enabled = False
frmMain_PGA308.cmbFrontEndGain.Enabled = False
frmMain_PGA308.cmbCoarseOffset.Enabled = False


End Sub
Public Sub Read_Controls()
If Updating_Controls = True Then Exit Sub


    '
    ' front_end_gain
    '
    front_end_gain = EngineeringVal(frmMain_PGA308.cmbFrontEndGain)
    PGA308Registers(2) = PGA308Registers(2) And (&HF0FF&) 'zero out bits that will change was e0ff
    PGA308Registers(2) = PGA308Registers(2) Or (Shift_Left(frmMain_PGA308.cmbFrontEndGain.ListIndex, 8))
    '
    ' PGA MUX
    '
    PGA308Registers(2) = PGA308Registers(2) And (&HEFFF&) 'zero out bits that will change
    PGA308Registers(2) = PGA308Registers(2) Or (Shift_Left(PGA308_mux, 12))
    If PGA308_mux = 1 Then
        mux_polarity = -1
        frmMain_PGA308.linSwap1.Visible = True
        frmMain_PGA308.linSwap2.Visible = True
        frmMain_PGA308.linPass1.Visible = False
        frmMain_PGA308.linPass2.Visible = False
    Else
        mux_polarity = 1
        frmMain_PGA308.linSwap1.Visible = False
        frmMain_PGA308.linSwap2.Visible = False
        frmMain_PGA308.linPass1.Visible = True
        frmMain_PGA308.linPass2.Visible = True
    End If

    '
    'output gain
    '
    If EngineeringVal(frmMain_PGA308.cmbOutputGain) = 0 Then
    Output_Amp_Gain = EngineeringVal(frmMain_PGA308.txtInternalFeedback)
    Else
    Output_Amp_Gain = EngineeringVal(frmMain_PGA308.cmbOutputGain)
    End If
    
    PGA308Registers(2) = PGA308Registers(2) And (&H1FFF&) 'zero out bits that will change
    PGA308Registers(2) = PGA308Registers(2) Or (Shift_Left(frmMain_PGA308.cmbOutputGain.ListIndex, 13) And (&HE000&))


    '
    'CoarseOffset
    '
    CoarseOffset = EngineeringVal(frmMain_PGA308.cmbCoarseOffset)
    PGA308Registers(2) = PGA308Registers(2) And (&HFF00&) 'zero out bits that will change
    PGA308Registers(2) = PGA308Registers(2) Or (frmMain_PGA308.cmbCoarseOffset.ListIndex)

    '
    'fine gain
    '
    If EngineeringVal(frmMain_PGA308.txtFineGain.Text) > 1 Then
        MsgBox "Fine Gain Out of Range.  Fine Gain Range:  0.33333 < Fine_Gain < 1.0000"
        PGA308Registers(1) = &HFFFF&
    ElseIf EngineeringVal(frmMain_PGA308.txtFineGain.Text) < 0.33333 Then
        If frmMain_PGA308.txtFineGain.Text <> "" Then MsgBox "Fine Gain Out of Range.  Fine Gain Range:  0.33333 < Fine_Gain < 1.0000"
        PGA308Registers(1) = 0
    Else
        PGA308Registers(1) = (EngineeringVal(frmMain_PGA308.txtFineGain.Text) - 0.33333333) / (0.000010172526)
        If PGA308Registers(1) < 0 Then PGA308Registers(1) = 0
    End If


    '
    'txtFineOffset
    '
    If EngineeringVal(frmMain_PGA308.txtFineOffset.Text) > 2.5 Then
        MsgBox "Zero DAC is out of range.  Range:  -2.5 < Fine_Gain < 2.5"
        PGA308Registers(0) = &HFFFF&
    ElseIf EngineeringVal(frmMain_PGA308.txtFineOffset.Text) < -2.5 Then
        MsgBox "Zero DAC is out of range.  Range:  -2.5 < Fine_Gain < 2.5"
        PGA308Registers(0) = 0
    Else
        If Vref_PGA308 <> 0 Then PGA308Registers(0) = (Vref_PGA308 / 2 - EngineeringVal(frmMain_PGA308.txtFineOffset.Text)) * 65536 / Vref_PGA308
    End If

    '
    ' chkShutDown
    '
    
    If frmMain_PGA308.chkShutDown.value = 1 Then
        PGA308Registers(4) = PGA308Registers(4) Or (&H40&)
    Else
        PGA308Registers(4) = PGA308Registers(4) And (&HFFBF&)
    End If
    '
    ' optDout
    '
     If frmMain_PGA308.optDout = True Then
         PGA308Registers(4) = PGA308Registers(4) Or (&H100&)
     Else
         PGA308Registers(4) = PGA308Registers(4) And (&HFEFF&)
     End If
    '
    ' txtDigOutput
    '
     If frmMain_PGA308.txtDigOutput = "1" Then
         PGA308Registers(4) = PGA308Registers(4) Or (&H80&)
     Else
         PGA308Registers(4) = PGA308Registers(4) And (&HFF7F&)
     End If
    
    '
    ' chkOTP_WriteEnable
    '
     If frmMain_PGA308.chkOTP_WriteEnable = 1 Then
          PGA308Registers(10) = PGA308Registers(10) Or (&H8000&)
      Else
          PGA308Registers(10) = PGA308Registers(10) And (&H7FFF&)
      End If
    
'
'  fault offset ref config -- Active_frmCorOffsetConf
'
If Active_frmCorOffsetConf = True Then
    '
    ' optCorRef1 -- coarse offset
    '
    If frmCorOffsetConf.optCorRef1 = True Then
        PGA308Registers(4) = PGA308Registers(4) And (&HF3FF&)
        Vref_int = 1 / 2
    ElseIf frmCorOffsetConf.optCorRef2 = True Then
        PGA308Registers(4) = PGA308Registers(4) And (&HF3FF&)
        PGA308Registers(4) = PGA308Registers(4) Or (&H400&)
        Vref_int = 1 / 3
    ElseIf frmCorOffsetConf.optCorRef3 = True Then
        PGA308Registers(4) = PGA308Registers(4) And (&HF3FF&)
        PGA308Registers(4) = PGA308Registers(4) Or (&H800&)
        Vref_int = 1 / 4
    ElseIf frmCorOffsetConf.optCorRef4 = True Then
        PGA308Registers(4) = PGA308Registers(4) And (&HF3FF&)
        PGA308Registers(4) = PGA308Registers(4) Or (&HC00&)
        Vref_int = 1 / 5
    End If
End If
'
'  end of fault offset ref config -- Active_frmCorOffsetConf
'

     
    
    '
    ' reset the corase offset bits
    '
    frmMain_PGA308.cmbCoarseOffset.Clear
    For i = 0 To &HFF&
    If (i And &H80&) = 0 Then
        Vcor = i * Vref_PGA308 * Vref_int * (2 * 4) / (195 * 41)
    Else
        Vcor = -(i And &H7F) * Vref_PGA308 * Vref_int * (2 * 4) / (195 * 41)
    End If
    frmMain_PGA308.cmbCoarseOffset.AddItem EuroFormat(Vcor * 1000, "0.0##") + "mV"
    Array_CoarseOffset(i) = Vcor

    Next i
    
    
    

     
    '
    'cmbUnderScale
    '
    UnderScale = EngineeringVal(frmMain_PGA308.cmbUnderScale)
    PGA308Registers(3) = PGA308Registers(3) And (&HFFF8&)
    If frmMain_PGA308.cmbUnderScale.ListIndex <> -1 Then PGA308Registers(3) = PGA308Registers(3) Or (frmMain_PGA308.cmbUnderScale.ListIndex)
 
    '
    'cmbOverScale
    '
    UnderScale = EngineeringVal(frmMain_PGA308.cmbOverScale)
    PGA308Registers(3) = PGA308Registers(3) And (&HFFC7&)
    If frmMain_PGA308.cmbOverScale.ListIndex <> -1 Then PGA308Registers(3) = PGA308Registers(3) Or (Shift_Left(frmMain_PGA308.cmbOverScale.ListIndex, 3))

    
    
 
    '
    'optBridgeFaultDetect vs optCMFaultDetect
    '
    If frmFaultReferences.optCMFaultDetect = True Then
        PGA308Registers(3) = PGA308Registers(3) Or (&H1000&)
    Else
        PGA308Registers(3) = PGA308Registers(3) And (&HEFFF&)
    End If
    '
    'optFaultRef_Vs
    '
    If frmFaultReferences.optFaultRef_Vs = True Then
        PGA308Registers(3) = PGA308Registers(3) Or (&H8000&)
    Else
        PGA308Registers(3) = PGA308Registers(3) And (&H7FFF&)
    End If
    
    
'
'  fault logic form -- frmConfigFaultLogic
'

If Active_frmConfigFaultLogic = True Then
     
   '
    'chkFaultExteranlEnable
    '
     If frmConfigFaultLogic.chkFaultExteranlEnable.value = 1 Then
         PGA308Registers(3) = PGA308Registers(3) Or (&H400&)
     Else
         PGA308Registers(3) = PGA308Registers(3) And (&HFBFF&)
     End If
    '
    'chkFaultInternallEnable
    '
     If frmConfigFaultLogic.chkFaultInternallEnable.value = 1 Then
         PGA308Registers(3) = PGA308Registers(3) Or (&H200&)
     Else
         PGA308Registers(3) = PGA308Registers(3) And (&HFDFF&)
     End If
    '
    'optExtPol_Vout_H optExtPol_Vout_L
    '
    If frmConfigFaultLogic.optExtPol_Vout_H = True Then
        PGA308Registers(3) = PGA308Registers(3) Or (&H100&)
    Else
        PGA308Registers(3) = PGA308Registers(3) And (&HFEFF&)
    End If
    '
    'optIntPol_Vout_H optIntPol_Vout_L
    '
    If frmConfigFaultLogic.optIntPol_Vout_H = True Then
        PGA308Registers(3) = PGA308Registers(3) Or (&H80&)
    Else
        PGA308Registers(3) = PGA308Registers(3) And (&HFF7F&)
    End If
End If
'
'  end of fault logic form -- frmConfigFaultLogic
'

'
'  over scale form -- frmOver_Under_Scale_Lim
'
If Active_frmOver_Under_Scale_Lim = True Then
    '
    ' chkOverUnderEn
    '
    If frmOver_Under_Scale_Lim.chkOverUnderEn.value = 1 Then
        PGA308Registers(3) = PGA308Registers(3) Or (&H40&)
        frmMain_PGA308.cmbUnderScale.Enabled = True
        frmMain_PGA308.cmbOverScale.Enabled = True
        'frmPre_Post_Cal_Preset.cmbUnderScale.Enabled = True 'APR-18-07
        'frmPre_Post_Cal_Preset.cmbOverScale.Enabled = True 'APR-18-07
    Else
        PGA308Registers(3) = PGA308Registers(3) And (&HFFBF&)
        frmMain_PGA308.cmbUnderScale.Enabled = False
        frmMain_PGA308.cmbOverScale.Enabled = False
        'frmPre_Post_Cal_Preset.cmbUnderScale.Enabled = False 'APR-18-07
        'frmPre_Post_Cal_Preset.cmbOverScale.Enabled = False 'APR-18-07
    End If

    '
    ' optOv_Ud_ref_Vref
    '
    If frmOver_Under_Scale_Lim.optOv_Ud_ref_Vsa = True Then
        PGA308Registers(3) = PGA308Registers(3) Or (&H2000&)
        Vref_over_under = Vsa
    Else
        PGA308Registers(3) = PGA308Registers(3) And (&HDFFF&)
        Vref_over_under = Vref_PGA308
    End If


End If
'
'  end of over scale form -- frmOver_Under_Scale_Lim
'

'
'  fault config monator -- Active_frmFaultConfigMonitor
'
If Active_frmFaultConfigMonitor = True Then
    If frmFaultConfigMonitor.chkEnableReferences = 1 Then
        PGA308Registers(3) = PGA308Registers(3) Or (&H4000&)
    Else
        PGA308Registers(3) = PGA308Registers(3) And (&HBFFF&)
    End If
End If

'
'  end fault config monator -- Active_frmFaultConfigMonitor
'


'
'  fault config ref -- Active_frmFaultReferences
'

If Active_frmFaultReferences = True Then
    If frmFaultReferences.optFaultRef_Vs = True Then
        PGA308Registers(3) = PGA308Registers(3) Or (&H8000&)
    Else
        PGA308Registers(3) = PGA308Registers(3) And (&H7FFF&)
    End If
    If frmFaultReferences.optCMFaultDetect = True Then
        PGA308Registers(3) = PGA308Registers(3) Or (&H1000&)
    Else
        PGA308Registers(3) = PGA308Registers(3) And (&HEFFF&)
    End If
End If
'
'  end fault config ref -- Active_frmFaultReferences
'


'
'  One-Wire config -- Active_frmOneWireConfig
'
If Active_frmOneWireConfig = True Then
    If frmOneWireConfig.chkOWD = 1 Then
        PGA308Registers(4) = PGA308Registers(4) Or (&H8000&)
    Else
        PGA308Registers(4) = PGA308Registers(4) And (&H7FFF&)
    End If
    If frmOneWireConfig.chkOWD_Off = 1 Then
        PGA308Registers(4) = PGA308Registers(4) Or (&H4000&)
    Else
        PGA308Registers(4) = PGA308Registers(4) And (&HBFFF&)
    End If
    If frmOneWireConfig.chkNOW = 1 Then
        PGA308Registers(4) = PGA308Registers(4) Or (&H1000&)
    Else
        PGA308Registers(4) = PGA308Registers(4) And (&HEFFF&)
    End If
    
    If frmOneWireConfig.chkDisOUT = 1 Then
        PGA308Registers(4) = PGA308Registers(4) Or (&H2000&)
    Else
        PGA308Registers(4) = PGA308Registers(4) And (&HDFFF&)
    End If
    
    If frmOneWireConfig.chkOW_DLY = 1 Then
        PGA308Registers(4) = PGA308Registers(4) Or (&H80&)
    Else
        PGA308Registers(4) = PGA308Registers(4) And (&HFF7F&)
    End If
    

End If
'
'  One-Wire config -- Active_frmOneWireConfig
'



If frmMain_PGA308.chkCurrentOutput = 1 Then
    Current_Output = True
    'frmMain_PGA308.optVoltageOut.value = False
    'frmMain_PGA308.optCurrentOut.value = True
    frmMain_PGA308.cmbOutputMode.ListIndex = 2
    frmPre_Post_Cal_Preset.cmbOutputMode.ListIndex = 2

    frmMain_PGA308.Picture1.Picture = LoadPicture(App.Path & "\pictures\pga308_Block_with_xtr.wmf")
    frmMain_PGA308.Picture2.Picture = LoadPicture(App.Path & "\pictures\sim_with_xtr.wmf")
    
    frmMain_PGA308.cmdXTR_Scaling.Enabled = True
    frmMain_PGA308.cmdReadXTR_Out.Visible = True
    frmMain_PGA308.cmdCalc_XTR_out.Visible = True
    frmMain_PGA308.txtIout.Visible = True
    frmMain_PGA308.txtCalcIout.Visible = True
    frmMain_PGA308.txtSIM(9).Visible = True
Else
    Current_Output = False
    'frmMain_PGA308.optVoltageOut.value = True
    'frmMain_PGA308.optCurrentOut.value = False
    frmMain_PGA308.Picture1.Picture = LoadPicture(App.Path & "\pictures\pga308_Block_no_xtr.wmf")
    frmMain_PGA308.Picture2.Picture = LoadPicture(App.Path & "\pictures\sim_no_xtr.wmf")
     
    frmMain_PGA308.cmdXTR_Scaling.Enabled = False
    frmMain_PGA308.cmdReadXTR_Out.Visible = False
    frmMain_PGA308.cmdCalc_XTR_out.Visible = False
    frmMain_PGA308.txtIout.Visible = False
    frmMain_PGA308.txtCalcIout.Visible = False
    frmMain_PGA308.txtSIM(9).Visible = False
    
    If OneWire_to_Vout = True Then
        frmMain_PGA308.cmbOutputMode.ListIndex = 1
        frmPre_Post_Cal_Preset.cmbOutputMode.ListIndex = 1
    Else
        frmMain_PGA308.cmbOutputMode.ListIndex = 0
        frmPre_Post_Cal_Preset.cmbOutputMode.ListIndex = 0
    End If
End If

Call UpdateRegisterDisplay

End Sub

Public Sub Save_Path2(path_to_save$)
'
'  This sub saves the prevous path used for file saves / loads
'

On Error GoTo exit_p2:

Open App.Path + "\" + "path_info2.txt" For Output As #35
Write #35, path_to_save$
Close #35
Exit Sub

exit_p2:
Close #35
old_path2 = ""

End Sub
Public Sub Save_Paths(what_path)
'
'  This sub saves the prevous path used for file saves / loads
'

On Error GoTo exit_p2:


If old_path1 = "" Then old_path1 = App.Path
If old_path2 = "" Then old_path2 = App.Path
If old_path3 = "" Then old_path3 = App.Path
If old_path4 = "" Then old_path4 = App.Path

If what_path = "PRE" Then
    old_path2 = old_pathx
ElseIf what_path = "POST" Then
    old_path3 = old_pathx
ElseIf what_path = "STORE" Then
    old_path4 = old_pathx
Else
    MsgBox "problem with what_path in Load paths"
End If


Open App.Path + "\" + "paths_info.txt" For Output As #35
Write #35, old_path1
Write #35, old_path2
Write #35, old_path3
Write #35, old_path4
Close #35
Exit Sub

exit_p2:
Close #35
old_path2 = ""

End Sub

Public Function V_to_Ixtr(Vin_xtr)
If ((R1_XTR + R2_XTR) <> 0) And (R_ref_i_in <> 0) Then
        V_to_Ixtr = 100 * (Vin_xtr / (R1_XTR + R2_XTR) + (V_xtr_ref / R_ref_i_in)) * 1000
Else
    V_xtr_ref = 4.096
    R_ref_i_in = 191000#
    R1_XTR = 10000
    R2_XTR = 11300
    C1_XTR = 0.000000015
    V_to_Ixtr = 100 * (Vin_xtr / (R1_XTR + R2_XTR) + (V_xtr_ref / R_ref_i_in)) * 1000
End If
End Function
Public Function Ixtr_to_Vo(Ixtr)
If ((R1_XTR + R2_XTR) <> 0) And (R_ref_i_in <> 0) Then
        'V_to_Ixtr = 100 * (Vin_xtr / (R1_XTR + R2_XTR) + (V_xtr_ref / R_ref_i_in)) * 1000
        Ixtr_to_Vo = (Ixtr / 100 - (V_xtr_ref / R_ref_i_in)) * (R1_XTR + R2_XTR)
Else
    V_xtr_ref = 4.096
    R_ref_i_in = 191000#
    R1_XTR = 10000
    R2_XTR = 11300
    C1_XTR = 0.000000015
        Ixtr_to_Vo = (Ixtr / 100 - (V_xtr_ref / R_ref_i_in)) * (R1_XTR + R2_XTR)
End If
End Function

Public Sub simulate()
If mux_polarity = 1 Then
frmMain_PGA308.pass_1.Visible = True
frmMain_PGA308.pass_2.Visible = True
frmMain_PGA308.inv_1.Visible = False
frmMain_PGA308.inv_2.Visible = False
Else
frmMain_PGA308.pass_1.Visible = False
frmMain_PGA308.pass_2.Visible = False
frmMain_PGA308.inv_1.Visible = True
frmMain_PGA308.inv_2.Visible = True

End If
Vcm_range_sim = EngineeringVal(frmMain_PGA308.txtVs)
Vcm_min_sim = 0
Vdif_sim = EngineeringVal(frmMain_PGA308.slider_vdif_sim) / 1000 * Vdif_range_sim + Vdif_min_sim
Vcm_sim = EngineeringVal(frmMain_PGA308.slider_vcm_sim) / 1000 * Vcm_range_sim + Vcm_min_sim

frmMain_PGA308.lbl_sim(7) = Vcm_min_sim
frmMain_PGA308.lbl_sim(8) = Vcm_range_sim + Vcm_min_sim
frmMain_PGA308.lbl_sim(5) = DisplayEngineering(Vdif_min_sim)
frmMain_PGA308.lbl_sim(6) = DisplayEngineering(Vdif_range_sim + Vdif_min_sim)



frmMain_PGA308.txtSIM(2) = EuroFormat(Vcm_sim + Vdif_sim / 2, "0.0##") 'vin+
frmMain_PGA308.txtSIM(0) = EuroFormat(Vcm_sim - Vdif_sim / 2, "0.0##") 'vin-
frmMain_PGA308.txtSIM(1) = DisplayEngineering(Vdif_sim)     'vdif


frmMain_PGA308.txtSIM(3) = frmMain_PGA308.cmbCoarseOffset
frmMain_PGA308.txtSIM(4) = frmMain_PGA308.cmbFrontEndGain
frmMain_PGA308.txtSIM(5) = frmMain_PGA308.txtFineOffset
frmMain_PGA308.txtSIM(6) = frmMain_PGA308.txtFineGain
frmMain_PGA308.txtSIM(7) = frmMain_PGA308.cmbOutputGain
Vcor = EngineeringVal(frmMain_PGA308.cmbCoarseOffset)
frmMain_PGA308.txtSIM(10) = EuroFormat(Vcm_sim, "0.0##")
frmMain_PGA308.txtSIM(11) = DisplayEngineering(Vdif_sim)

V1 = Vcm_sim + (mux_polarity * Vdif_sim / 2 - c_sign * Vcor / 2) * EngineeringVal(frmMain_PGA308.cmbFrontEndGain) / 4
frmMain_PGA308.lbl_sim(0) = "V= " + EuroFormat(V1, "0.0##") + vbCrLf + "0.05 < V <" + Str(EngineeringVal(frmMain_PGA308.txtVs) - 0.1)

V2 = Vcm_sim - (mux_polarity * Vdif_sim / 2 - c_sign * Vcor / 2) * EngineeringVal(frmMain_PGA308.cmbFrontEndGain) / 4
frmMain_PGA308.lbl_sim(1) = "V= " + EuroFormat(V2, "0.0##") + vbCrLf + "0.05 < V <" + Str(EngineeringVal(frmMain_PGA308.txtVs) - 0.1)

V3 = (mux_polarity * Vdif_sim - c_sign * EngineeringVal(frmMain_PGA308.cmbCoarseOffset)) * EngineeringVal(frmMain_PGA308.cmbFrontEndGain) + EngineeringVal(frmMain_PGA308.txtFineOffset)
frmMain_PGA308.lbl_sim(2) = "V= " + EuroFormat(V3, "0.0##") + vbCrLf + "0.05 < V <" + Str(EngineeringVal(frmMain_PGA308.txtVs) - 0.1)

V4 = ((mux_polarity * Vdif_sim - c_sign * EngineeringVal(frmMain_PGA308.cmbCoarseOffset)) * EngineeringVal(frmMain_PGA308.cmbFrontEndGain) + EngineeringVal(frmMain_PGA308.txtFineOffset)) * EngineeringVal(frmMain_PGA308.txtFineGain)
frmMain_PGA308.lbl_sim(3) = "V= " + EuroFormat(V4, "0.0##") + vbCrLf + "0.05 < V <" + Str(EngineeringVal(frmMain_PGA308.txtVs) - 1.2)

V5 = ((mux_polarity * Vdif_sim - c_sign * EngineeringVal(frmMain_PGA308.cmbCoarseOffset)) * EngineeringVal(frmMain_PGA308.cmbFrontEndGain) + EngineeringVal(frmMain_PGA308.txtFineOffset)) * EngineeringVal(frmMain_PGA308.txtFineGain) * EngineeringVal(frmMain_PGA308.cmbOutputGain)
frmMain_PGA308.lbl_sim(4) = "V= " + EuroFormat(V5, "0.0##") + vbCrLf + "0.05 < V <" + Str(EngineeringVal(frmMain_PGA308.txtVs) - 0.1)

frmMain_PGA308.txtSIM(8) = EuroFormat(V5, "0.0##")

I_sim = ((0.016 / 4) * (V5 - 0.5) + 0.004) * 1000
frmMain_PGA308.txtSIM(9) = EuroFormat(I_sim, "0.0##")

If (V1 < 0.05) Or (V1 > (EngineeringVal(frmMain_PGA308.txtVs) - 0.1)) Then
frmMain_PGA308.lbl_sim(0).ForeColor = &HFF&
Else
frmMain_PGA308.lbl_sim(0).ForeColor = &H0&
End If

If (V2 < 0.05) Or (V2 > (EngineeringVal(frmMain_PGA308.txtVs) - 0.1)) Then
frmMain_PGA308.lbl_sim(1).ForeColor = &HFF&
Else
frmMain_PGA308.lbl_sim(1).ForeColor = &H0&
End If

If (V3 < 0.05) Or (V3 > (EngineeringVal(frmMain_PGA308.txtVs) - 0.1)) Then
frmMain_PGA308.lbl_sim(2).ForeColor = &HFF&
Else
frmMain_PGA308.lbl_sim(2).ForeColor = &H0&
End If

If (V4 < 0.05) Or (V4 > (EngineeringVal(frmMain_PGA308.txtVs) - 1.2)) Then
frmMain_PGA308.lbl_sim(3).ForeColor = &HFF&
Else
frmMain_PGA308.lbl_sim(3).ForeColor = &H0&
End If

If (V5 < 0.05) Or (V5 > (EngineeringVal(frmMain_PGA308.txtVs) - 0.1)) Then
frmMain_PGA308.lbl_sim(4).ForeColor = &HFF&
Else
frmMain_PGA308.lbl_sim(4).ForeColor = &H0&
End If

End Sub
Public Sub Load_Path2()
'
'  This sub loads the prevous path used for file saves / loads
'

On Error GoTo exit_p1:

Open App.Path + "\" + "path_info2.txt" For Input As #35
Input #35, old_path2
Close #35
Exit Sub
exit_p1:
Close #35
old_path2 = ""
End Sub
Public Sub Load_Paths(what_path)
'
'  This sub loads the prevous path used for file saves / loads
'

On Error GoTo exit_p1:

Open App.Path + "\" + "paths_info.txt" For Input As #35
Input #35, old_path1
Input #35, old_path2
Input #35, old_path3
Input #35, old_path4
Close #35

If what_path = "PRE" Then
    old_pathx = old_path2
ElseIf what_path = "POST" Then
    old_pathx = old_path3
ElseIf what_path = "STORE" Then
    old_pathx = old_path4
Else
    MsgBox "problem with what_path in Load paths"
End If


Exit Sub
exit_p1:
Close #35
old_path2 = ""
End Sub

Public Sub Ld_sel_OTP_bank_1W_to_vout(Bank_No)
        Call RunMnemonicCommand("CMD OFF")
        Call pause(0.1)
        Call RunMnemonicCommand("CMD WAKE_UP_ONE") 'done


'Bank_No = OTP_Bank_Pointer
For Reg_No = 0 To 5
    Bank_Pointer = Shift_Left(Bank_No, 3)
    Read_notWrite = &H80&  'read = &H80&, write = &H00&
    Bank_notSoftware = &H40& 'B/notR = &H40& for bank, B/notR = &H00& for software
    OTP_Address = Bank_notSoftware Or Read_notWrite Or Bank_Pointer Or Reg_No
    Call RunMnemonicCommand("ONE 55 " + Hex(OTP_Address) + " R R ")
    PGA308_OTP(reg, Bank) = Shift_Left(ReadData(1), 8) + ReadData(0)
    REG_MSB = ReadData(1)
    REG_LSB = ReadData(0)
    Call RunMnemonicCommand("ONE 55 " + Hex(Reg_No) + " " + Hex(REG_LSB) + " " + Hex(REG_MSB)) 'Copy into RAM
Next Reg_No
'Call Read_All_Reg  'update display 7/31/07





    Call RunMnemonicCommand("ONE 55 " + Hex(6 + &H80&) + " R R ") ' read Internaly calculated checksum reg
    PGA308Registers(6) = Shift_Left(ReadData(1), 8) + ReadData(0)
    REG_MSB = ReadData(1)
    REG_LSB = ReadData(0)
    Call RunMnemonicCommand("ONE 55 " + Hex(5) + " " + Hex(REG_LSB) + " " + Hex(REG_MSB))   'write checksum Reg
    Call RunMnemonicCommand("ONE 55 " + Hex(5 + &H80&) + " R R ") ' read Internaly calculated checksum reg
    PGA308Registers(5) = Shift_Left(ReadData(1), 8) + ReadData(0)
   'MsgBox "PGA308Registers(5)=" + Hex(PGA308Registers(5)) + vbCrLf + "PGA308Registers(6)=" + Hex(PGA308Registers(6))


For i = 0 To &HF&
    Call RunMnemonicCommand("ONE 55 " + Hex(i + &H80&) + " R R ") ' read Internaly calculated checksum reg
        If ReadData(30) <> 0 Then
            MsgBox "timeout on One-Wire transaction"
        End If
        PGA308Registers(i) = Shift_Left(ReadData(1), 8) + ReadData(0)
Next i

Call UpdateRegisterDisplay

With frmMain_PGA308.gridReg
    For i = 0 To MaxReg
        .TextMatrix(i + 1, 1) = TestNames(i + 1) 'reset reg edited indicater
    Next i
End With

With frmMain_PGA308.fgrid_RAM
    For i = 0 To 5
        .TextMatrix(i + 1, 1) = Hex(PGA308Registers(i))
    Next i
End With

    If OneWire_to_Vout = True Then
        Call RunMnemonicCommand("CMD EN_ONE OFF ") 'EN_ONE ON (or OFF)
    End If

End Sub
Public Sub WriteOTP(Bank_No, Reg_No)
        'Bank_Pointer = Shift_Left(Bank_No, 3)
        'Read_notWrite = &H0&  'read = &H80&, write = &H00&
        'Bank_notSoftware = &H40& 'B/notR = &H40& for bank, B/notR = &H00& for software
        'OTP_Address = Bank_notSoftware Or Read_notWrite Or Bank_Pointer Or Reg_No
        'Call RunMnemonicCommand("ONE 55 " + Hex(OTP_Address) + " R R ")
        'PGA308_OTP(REG, Bank) = Shift_Left(ReadData(1), 8) + ReadData(0)
End Sub

Public Sub Read_All_Reg_Normal()
For i = 0 To MaxReg
    frmMain_PGA308.ProgressBar1.value = i * 100 / MaxReg
    Call RunMnemonicCommand("ONE 55 " + Hex(i + &H80&) + " R R ")
    PGA308Registers(i) = Shift_Left(ReadData(1), 8) + ReadData(0)
    OldReg(i) = PGA308Registers(i)
    MarkRegForWrite(i) = False
Next i
Call UpdateRegisterDisplay

With frmMain_PGA308.gridReg
    For i = 0 To MaxReg
        .TextMatrix(i + 1, 1) = TestNames(i + 1) 'reset reg edited indicater
    Next i
End With

With frmMain_PGA308.fgrid_RAM
    For i = 0 To 5
        .TextMatrix(i + 1, 1) = Hex(PGA308Registers(i))
    Next i
End With

End Sub

Public Sub Update_Controls()
Updating_Controls = True
  
    Vsa = EngineeringVal(frmMain_PGA308.txtVs) 'aug 15
    Vref_PGA308 = EngineeringVal(frmMain_PGA308.txtVref_PGA308) 'aug 15

    '
    ' front_end_gain
    '
    frmMain_PGA308.cmbFrontEndGain.ListIndex = Shift_Right(PGA308Registers(2) And (&HF00&), 8) 'WAS 1F00
    '
    ' PGA308 INPUT MUX
    '
    '
    PGA308_mux = Shift_Right(PGA308Registers(2) And (&H1000&), 12)
    If PGA308_mux = 1 Then
        mux_polarity = -1
        frmMain_PGA308.linSwap1.Visible = True
        frmMain_PGA308.linSwap2.Visible = True
        frmMain_PGA308.linPass1.Visible = False
        frmMain_PGA308.linPass2.Visible = False
    Else
        mux_polarity = 1
        frmMain_PGA308.linSwap1.Visible = False
        frmMain_PGA308.linSwap2.Visible = False
        frmMain_PGA308.linPass1.Visible = True
        frmMain_PGA308.linPass2.Visible = True
    End If

    '
    ' chkOTP_WriteEnable
    '
      If PGA308Registers(10) And (&H8000&) = (&H8000&) Then
           frmMain_PGA308.chkOTP_WriteEnable = 1
       Else
           frmMain_PGA308.chkOTP_WriteEnable = 0
       End If
   
    '
    'output gain
    '
     
    frmMain_PGA308.cmbOutputGain.ListIndex = Shift_Right(PGA308Registers(2) And (&HE000&), 13)

    '
    'fine gain
    '
      frmMain_PGA308.txtFineGain.Text = EuroFormat((0.000010172526 * PGA308Registers(1) + 0.33333333), "#.######")

    '
    'txtFineOffset
    '
    frmMain_PGA308.txtFineOffset.Text = EuroFormat((Vref_PGA308 / 2) - (PGA308Registers(0) * Vref_PGA308 / 65536), "#.######")
    
    '
    ' chkShutDown
    '
    frmMain_PGA308.chkShutDown.value = Shift_Right(PGA308Registers(4), 6) And (&H1&)
    
    '
    '  optRAM optOTP PGA308Registers(7) = PGA308Registers(7) And (&HFFAF&)
    '
    If OneWire_to_Vout = False Then
        If (PGA308Registers(7) And (&H50&)) = &H50& Then
            If (PGA308Registers(7) And (&H5F&)) = &H50 Then
                frmMain_PGA308.optRAM = True 'copy bank into ram and run out of ram
                frmMain_PGA308.optOTP = False
                frmMain_PGA308.otpBank = False
           Else
                frmMain_PGA308.optRAM = False 'run out of ram
                frmMain_PGA308.optOTP = False
                frmMain_PGA308.otpBank = True
            End If
        Else
            frmMain_PGA308.optRAM = False 'run out of OTP
            frmMain_PGA308.optOTP = True
            frmMain_PGA308.otpBank = False
        End If
    Else
    'NOT DONE
        'If (PGA308Registers(7) And (&H50&)) = &H50& Then
        '    MsgBox "Software Lock Mode is not recomended with the PGA308"
        'Else
        
        'End If
    End If
'
' frmOver_Under_Scale_Lim
'
If Active_frmOver_Under_Scale_Lim = True Then
    '
    ' chkOverUnderEn
    '
    frmOver_Under_Scale_Lim.chkOverUnderEn.value = Shift_Right(PGA308Registers(3), 6) And (&H1&)
    If (Shift_Right(PGA308Registers(3), 6) And (&H1&)) = 1 Then
            frmMain_PGA308.cmbUnderScale.Enabled = True
            frmMain_PGA308.cmbOverScale.Enabled = True
    Else
            frmMain_PGA308.cmbUnderScale.Enabled = False
            frmMain_PGA308.cmbOverScale.Enabled = False
    End If
    '
    ' optOv_Ud_ref_Vref
    '
    If (PGA308Registers(3) And (&H2000&)) = &H2000& Then
        frmOver_Under_Scale_Lim.optOv_Ud_ref_Vsa = True
        frmOver_Under_Scale_Lim.optOv_Ud_ref_Vref = False
        frmOver_Under_Scale_Lim.Line_Vsa = True
        frmOver_Under_Scale_Lim.Line_Vref = False
          Vref_over_under = Vsa
    Else
        frmOver_Under_Scale_Lim.optOv_Ud_ref_Vsa = False
        frmOver_Under_Scale_Lim.optOv_Ud_ref_Vref = True
         Vref_over_under = Vref_PGA308
        frmOver_Under_Scale_Lim.Line_Vsa = False
        frmOver_Under_Scale_Lim.Line_Vref = True
   End If
Else
  ' frmOver_Under_Scale_Lim.chkOverUnderEn.value = Shift_Right(PGA308Registers(3), 6) And (&H1&)
    If (Shift_Right(PGA308Registers(3), 6) And (&H1&)) = 1 Then
            frmMain_PGA308.cmbUnderScale.Enabled = True
            frmMain_PGA308.cmbOverScale.Enabled = True
    Else
            frmMain_PGA308.cmbUnderScale.Enabled = False
            frmMain_PGA308.cmbOverScale.Enabled = False
    End If
    '
    ' optOv_Ud_ref_Vref
    '
    If (PGA308Registers(3) And (&H2000&)) = &H2000& Then
        'frmOver_Under_Scale_Lim.optOv_Ud_ref_Vsa = True
        'frmOver_Under_Scale_Lim.optOv_Ud_ref_Vref = False
          Vref_over_under = Vsa
    Else
        'frmOver_Under_Scale_Lim.optOv_Ud_ref_Vsa = False
        'frmOver_Under_Scale_Lim.optOv_Ud_ref_Vref = True
         Vref_over_under = Vref_PGA308
   End If

End If
'
' end of -- frmOver_Under_Scale_Lim
'

    '
    ' reset the over  bits
    '
    frmMain_PGA308.cmbOverScale.Clear
    frmMain_PGA308.cmbOverScale.AddItem EuroFormat(Vref_over_under * 0.9805, "0.0##") + "V"
    frmMain_PGA308.cmbOverScale.AddItem EuroFormat(Vref_over_under * 0.9688, "0.0##") + "V"
    frmMain_PGA308.cmbOverScale.AddItem EuroFormat(Vref_over_under * 0.9609, "0.0##") + "V"
    frmMain_PGA308.cmbOverScale.AddItem EuroFormat(Vref_over_under * 0.9492, "0.0##") + "V"
    frmMain_PGA308.cmbOverScale.AddItem EuroFormat(Vref_over_under * 0.8516, "0.0##") + "V"
    frmMain_PGA308.cmbOverScale.AddItem EuroFormat(Vref_over_under * 0.7773, "0.0##") + "V"
    frmMain_PGA308.cmbOverScale.AddItem EuroFormat(Vref_over_under * 0.6289, "0.0##") + "V"
    frmMain_PGA308.cmbOverScale.AddItem EuroFormat(Vref_over_under * 0.5703, "0.0##") + "V"
    '
    ' reset the under  bits
    '
    frmMain_PGA308.cmbUnderScale.Clear
    frmMain_PGA308.cmbUnderScale.AddItem EuroFormat(Vref_over_under * 0.01953, "0.0##") + "V"
    frmMain_PGA308.cmbUnderScale.AddItem EuroFormat(Vref_over_under * 0.02343, "0.0##") + "V"
    frmMain_PGA308.cmbUnderScale.AddItem EuroFormat(Vref_over_under * 0.03125, "0.0##") + "V"
    frmMain_PGA308.cmbUnderScale.AddItem EuroFormat(Vref_over_under * 0.03516, "0.0##") + "V"
    frmMain_PGA308.cmbUnderScale.AddItem EuroFormat(Vref_over_under * 0.03906, "0.0##") + "V"
    frmMain_PGA308.cmbUnderScale.AddItem EuroFormat(Vref_over_under * 0.04688, "0.0##") + "V"
    frmMain_PGA308.cmbUnderScale.AddItem EuroFormat(Vref_over_under * 0.05078, "0.0##") + "V"
    frmMain_PGA308.cmbUnderScale.AddItem EuroFormat(Vref_over_under * 0.0547, "0.0##") + "V"
    
  If frmMain_PGA308.chkCurrentOutput = 1 Then
  
   '
    ' reset the over  bits
    '
    frmMain_PGA308.cmbOverScale.Clear

    frmMain_PGA308.cmbOverScale.AddItem EuroFormat(V_to_Ixtr(Vref_over_under * 0.9805), "0.0##") + "mA"
    frmMain_PGA308.cmbOverScale.AddItem EuroFormat(V_to_Ixtr(Vref_over_under * 0.9688), "0.0##") + "mA"
    frmMain_PGA308.cmbOverScale.AddItem EuroFormat(V_to_Ixtr(Vref_over_under * 0.9609), "0.0##") + "mA"
    frmMain_PGA308.cmbOverScale.AddItem EuroFormat(V_to_Ixtr(Vref_over_under * 0.9492), "0.0##") + "mA"
    frmMain_PGA308.cmbOverScale.AddItem EuroFormat(V_to_Ixtr(Vref_over_under * 0.8516), "0.0##") + "mA"
    frmMain_PGA308.cmbOverScale.AddItem EuroFormat(V_to_Ixtr(Vref_over_under * 0.7773), "0.0##") + "mA"
    frmMain_PGA308.cmbOverScale.AddItem EuroFormat(V_to_Ixtr(Vref_over_under * 0.6289), "0.0##") + "mA"
    frmMain_PGA308.cmbOverScale.AddItem EuroFormat(V_to_Ixtr(Vref_over_under * 0.5703), "0.0##") + "mA"
    '
    ' reset the over  bits
    '
    frmMain_PGA308.cmbUnderScale.Clear
    frmMain_PGA308.cmbUnderScale.AddItem EuroFormat(V_to_Ixtr(Vref_over_under * 0.01953), "0.0##") + "mA"
    frmMain_PGA308.cmbUnderScale.AddItem EuroFormat(V_to_Ixtr(Vref_over_under * 0.02343), "0.0##") + "mA"
    frmMain_PGA308.cmbUnderScale.AddItem EuroFormat(V_to_Ixtr(Vref_over_under * 0.03125), "0.0##") + "mA"
    frmMain_PGA308.cmbUnderScale.AddItem EuroFormat(V_to_Ixtr(Vref_over_under * 0.03516), "0.0##") + "mA"
    frmMain_PGA308.cmbUnderScale.AddItem EuroFormat(V_to_Ixtr(Vref_over_under * 0.03906), "0.0##") + "mA"
    frmMain_PGA308.cmbUnderScale.AddItem EuroFormat(V_to_Ixtr(Vref_over_under * 0.04688), "0.0##") + "mA"
    frmMain_PGA308.cmbUnderScale.AddItem EuroFormat(V_to_Ixtr(Vref_over_under * 0.05078), "0.0##") + "mA"
    frmMain_PGA308.cmbUnderScale.AddItem EuroFormat(V_to_Ixtr(Vref_over_under * 0.0547), "0.0##") + "mA"

  
  End If
    
    
    '
    'cmbUnderScale
    '
    frmMain_PGA308.cmbUnderScale.ListIndex = PGA308Registers(3) And (&H7&)
 
    '
    'cmbOverScale
    '
    frmMain_PGA308.cmbOverScale.ListIndex = Shift_Right(PGA308Registers(3), 3) And (&H7&)

'
'
'
'



'
'
'
'

    '
    ' optDout
    '
    X = Hex(PGA308Registers(4))
    If (PGA308Registers(4) And (&H100&)) = &H100& Then
        frmMain_PGA308.optDout = True
        frmMain_PGA308.optClamp = False
        
    Else
        frmMain_PGA308.optDout = False
        frmMain_PGA308.optClamp = True
    End If
    '
    ' txtDigOutput
    '
    frmMain_PGA308.txtDigOutput = Right(Str(Shift_Right(PGA308Registers(4), 7) And (&H1&)), 1)
    '
    'optBridgeFaultDetect vs optCMFaultDetect
    '
    If (PGA308Registers(3) And (&H1000&)) = &H1000& Then
        frmFaultReferences.optCMFaultDetect = True
        frmFaultReferences.optBridgeFaultDetect = False
    Else
        frmFaultReferences.optCMFaultDetect = False
        frmFaultReferences.optBridgeFaultDetect = True
    End If
    '
    'optFaultRef_Vs vs optFaultRef_Vref
    '
    If (PGA308Registers(3) And (&H8000&)) = &H8000& Then
        frmFaultReferences.optFaultRef_Vs = True
        frmFaultReferences.optFaultRef_Vref = False
    Else
        frmFaultReferences.optFaultRef_Vs = False
        frmFaultReferences.optFaultRef_Vref = True
    End If
    
    '
    'chkFaultExteranlEnable
    '
    If (PGA308Registers(3) And (&H400&)) = &H400& Then
        frmConfigFaultLogic.chkFaultExteranlEnable.value = 1
    Else
        frmConfigFaultLogic.chkFaultExteranlEnable.value = 0
    End If
     

'
'  fault logic form -- frmConfigFaultLogic
'

If Active_frmConfigFaultLogic = True Then
    frmConfigFaultLogic.Line1_dout_sel_sda.Visible = frmMain_PGA308.optDout.value
    frmConfigFaultLogic.Line1_vclamp_sel_sda.Visible = frmMain_PGA308.optClamp.value
    frmConfigFaultLogic.Line2_dout_sel_sda.Visible = frmMain_PGA308.optDout.value
    frmConfigFaultLogic.Line2_vclamp_sel_sda.Visible = frmMain_PGA308.optClamp.value
    '
    ' frmConfigFaultLogic.txtFault(i)
    '
    For i = 0 To 8
        frmConfigFaultLogic.txtFault(i) = Shift_Right(PGA308Registers(9) And (2 ^ i), i) 'was i^2 changed May 9
    Next i
    If (PGA308Registers(4) And (&H100&)) = &H100& Then
        'frmMain_PGA308.optDout = True
        'frmMain_PGA308.optClamp = False
        frmConfigFaultLogic.txtOutDoutSel(0) = Str(Vsa) + "V"
        frmConfigFaultLogic.txtOutDoutSel(1) = Str(Vsa) + "V"
    Else
        'frmMain_PGA308.optDout = False
        'frmMain_PGA308.optClamp = True
        frmConfigFaultLogic.txtOutDoutSel(0) = frmMain_PGA308.txtDoutVclamp + "V"
        frmConfigFaultLogic.txtOutDoutSel(1) = frmMain_PGA308.txtDoutVclamp + "V"
        
    End If
    
    If frmConfigFaultLogic.optExtPol_Vout_H = True Then
        frmConfigFaultLogic.txtExtpol_Vout = frmConfigFaultLogic.txtOutDoutSel(0)

         frmConfigFaultLogic.Line2_ExtPol_Vout_H = True
         frmConfigFaultLogic.Line2_ExtPol_Vout_L = False
    Else
        frmConfigFaultLogic.txtExtpol_Vout = "0V"
         frmConfigFaultLogic.Line2_ExtPol_Vout_H = False
         frmConfigFaultLogic.Line2_ExtPol_Vout_L = True
    End If
    
    If frmConfigFaultLogic.optIntPol_Vout_H = True Then
     frmConfigFaultLogic.txtInt_Vol = frmConfigFaultLogic.txtOutDoutSel(1)
         frmConfigFaultLogic.Line1_IntPol_Vout_H = True
        frmConfigFaultLogic.Line1_IntPol_Vout_L = False
  Else
        frmConfigFaultLogic.txtInt_Vol = "0V"
        frmConfigFaultLogic.Line1_IntPol_Vout_H = False
        frmConfigFaultLogic.Line1_IntPol_Vout_L = True
    End If
    in_a = EngineeringVal(frmConfigFaultLogic.txtFault(0))
    in_b = EngineeringVal(frmConfigFaultLogic.txtFault(1))
    in_c = EngineeringVal(frmConfigFaultLogic.txtFault(2))
    in_d = EngineeringVal(frmConfigFaultLogic.txtFault(3))

     frmConfigFaultLogic.txtExterFault = (in_a) Or (in_b) Or (in_c) Or (in_d)
     
     
     frmConfigFaultLogic.txtExterFault_And_EN = EngineeringVal(frmConfigFaultLogic.chkFaultExteranlEnable) And (EngineeringVal(frmConfigFaultLogic.txtExterFault))
 'txtExterFault_And_EN
    If EngineeringVal(frmConfigFaultLogic.txtExterFault_And_EN) = 1 Then
        frmConfigFaultLogic.Line1_External_ON.Visible = True
        frmConfigFaultLogic.Line1_External_OFF.Visible = False
        frmConfigFaultLogic.txtOutputVout = "External Fault Vout=" + frmConfigFaultLogic.txtExtpol_Vout
    Else
        frmConfigFaultLogic.Line1_External_ON.Visible = False
        frmConfigFaultLogic.Line1_External_OFF.Visible = True
    End If
 
    in_e = EngineeringVal(frmConfigFaultLogic.txtFault(4))
    in_f = EngineeringVal(frmConfigFaultLogic.txtFault(5))
    in_g = EngineeringVal(frmConfigFaultLogic.txtFault(6))
    in_h = EngineeringVal(frmConfigFaultLogic.txtFault(7))
    in_i = EngineeringVal(frmConfigFaultLogic.txtFault(8))
    
       frmConfigFaultLogic.txtIntFaultOR = (in_e) Or (in_f) Or (in_g) Or (in_h) Or (in_i)
       frmConfigFaultLogic.txtIntFault_And_EN = EngineeringVal(frmConfigFaultLogic.chkFaultInternallEnable) And (EngineeringVal(frmConfigFaultLogic.txtIntFaultOR))
  'txtIntFault_And_EN
    If EngineeringVal(frmConfigFaultLogic.txtIntFault_And_EN) = 1 Then
        frmConfigFaultLogic.Line1_INT_ON.Visible = True
        frmConfigFaultLogic.Line1_INT_OFF.Visible = False
        frmConfigFaultLogic.txtOutputVout = "Internal Fault Vout=" + frmConfigFaultLogic.txtInt_Vol
    Else
        frmConfigFaultLogic.Line1_INT_ON.Visible = False
        frmConfigFaultLogic.Line1_INT_OFF.Visible = True
    End If
 
 
 If (EngineeringVal(frmConfigFaultLogic.txtExterFault_And_EN) = 0) And (EngineeringVal(frmConfigFaultLogic.txtIntFault_And_EN) = 0) Then
 frmConfigFaultLogic.txtOutputVout = "No Detected Fault Output"
 End If
 
 
    '
    'chkFaultInternallEnable
    '
        If (PGA308Registers(3) And (&H200&)) = &H200& Then
            frmConfigFaultLogic.chkFaultInternallEnable.value = 1
        Else
            frmConfigFaultLogic.chkFaultInternallEnable.value = 0
        End If
    '
    'optExtPol_Vout_H optExtPol_Vout_L
    '
    If (PGA308Registers(3) And (&H100&)) = &H100& Then
        frmConfigFaultLogic.optExtPol_Vout_H = True
        frmConfigFaultLogic.optExtPol_Vout_L = False
    Else
        frmConfigFaultLogic.optExtPol_Vout_H = False
        frmConfigFaultLogic.optExtPol_Vout_L = True
    End If
    
    '
    'optIntPol_Vout_H optIntPol_Vout_L
    '
    If (PGA308Registers(3) And (&H80&)) = &H80& Then
        frmConfigFaultLogic.optIntPol_Vout_H = True
        frmConfigFaultLogic.optIntPol_Vout_L = False
    Else
        frmConfigFaultLogic.optIntPol_Vout_H = False
        frmConfigFaultLogic.optIntPol_Vout_L = True
    End If
End If


'
'  end of fault logic form -- frmConfigFaultLogic
'










'
'  fault config ref -- Active_frmFaultReferences
'

If Active_frmFaultReferences = True Then
    If (PGA308Registers(3) And (&H8000&)) = (&H8000&) Then
        frmFaultReferences.optFaultRef_Vs = True
        frmFaultReferences.optFaultRef_Vref = False
        Vflt = Vsa
    Else
        frmFaultReferences.optFaultRef_Vs = False
        frmFaultReferences.optFaultRef_Vref = True
        Vflt = Vref_PGA308
    End If
    If (PGA308Registers(3) And (&H1000&)) = (&H1000&) Then
        frmFaultReferences.optCMFaultDetect = True
        frmFaultReferences.optBridgeFaultDetect = False
        Vfault_p = Vsa - 1.2
        Vfault_n = 0.1
        frmFaultReferences.txtFLT_p(0) = Vfault_p
        frmFaultReferences.txtFLT_n(0) = Vfault_n
    Else
        frmFaultReferences.optCMFaultDetect = False
        frmFaultReferences.optBridgeFaultDetect = True
        
        If (Vsa - 1.2) < (0.65 * Vflt) Then
        Vfault_p = Vsa - 1.2
        frmFaultReferences.txtFLT_p(0) = Vfault_p
        Else
        Vfault_p = (0.65 * Vflt)
        frmFaultReferences.txtFLT_p(0) = Vfault_p
        End If
        If (0.1) > (0.35 * Vflt) Then
        Vfault_n = 0.1
        frmFaultReferences.txtFLT_n(0) = Vfault_n
        Else
        Vfault_n = (0.35 * Vflt)
        frmFaultReferences.txtFLT_n(0) = (0.35 * Vflt)
        End If
    End If
    If frmFaultReferences.optCMFaultDetect = True Then
        frmFaultReferences.Line1_CommonMode.Visible = True
        frmFaultReferences.Line2_CommonMode.Visible = True
        frmFaultReferences.Line1_Bridge.Visible = False
        frmFaultReferences.Line2_Bridge.Visible = False
    Else
        frmFaultReferences.Line1_CommonMode.Visible = False
        frmFaultReferences.Line2_CommonMode.Visible = False
        frmFaultReferences.Line1_Bridge.Visible = True
        frmFaultReferences.Line2_Bridge.Visible = True
    End If
    frmFaultReferences.txtVs_m1p2 = EuroFormat((Vsa - 1.2), "##.##")
    frmFaultReferences.txt_p65Vflt = EuroFormat((0.65 * Vflt), "##.##")
    frmFaultReferences.txt_p35Vflt = EuroFormat((0.35 * Vflt), "##.##")
    If frmFaultReferences.optFaultRef_Vs = True Then
    frmFaultReferences.Line1_Vflt_Vs.Visible = True
    frmFaultReferences.Line1_Vflt_Vref.Visible = False
    Else
    frmFaultReferences.Line1_Vflt_Vs.Visible = False
    frmFaultReferences.Line1_Vflt_Vref.Visible = True
    
    End If
Else
    If (PGA308Registers(3) And (&H8000&)) = (&H8000&) Then
        Vflt = Vsa
    Else
        Vflt = Vref_PGA308
    End If
    If (PGA308Registers(3) And (&H1000&)) = (&H1000&) Then
        Vfault_p = Vsa - 1.2
        Vfault_n = 0.1
    Else
        If (Vsa - 1.2) < (0.65 * Vflt) Then
        Vfault_p = (Vsa - 1.2)
        Else
        Vfault_p = (0.65 * Vflt)
        End If
        If (0.1) > (0.35 * Vflt) Then
        Vfault_n = (0.1)
        Else
        Vfault_n = (0.35 * Vflt)
        End If
    End If

    
End If
'
'  end fault config ref -- Active_frmFaultReferences
'





'
'  fault config monator -- Active_frmFaultConfigMonitor
'
If Active_frmFaultConfigMonitor = True Then
    If (PGA308Registers(3) And (&H4000&)) = &H4000& Then
        frmFaultConfigMonitor.chkEnableReferences = 1
        frmFaultConfigMonitor.Line1_dis_fault_ref.Visible = True
        frmFaultConfigMonitor.Line2_dis_fault_ref.Visible = True
        frmFaultConfigMonitor.Line1_ena_fault_ref.Visible = False
        frmFaultConfigMonitor.Line2_ena_fault_ref.Visible = False
    Else
        frmFaultConfigMonitor.chkEnableReferences = 0
        'frmFaultConfigMonitor.chkEnableReferences = 1
        frmFaultConfigMonitor.Line1_dis_fault_ref.Visible = False
        frmFaultConfigMonitor.Line2_dis_fault_ref.Visible = False
        frmFaultConfigMonitor.Line1_ena_fault_ref.Visible = True
        frmFaultConfigMonitor.Line2_ena_fault_ref.Visible = True
    End If
    frmFaultConfigMonitor.txtFLT_p(0) = Vfault_p
    frmFaultConfigMonitor.txtFLT_n(0) = Vfault_n
    frmFaultConfigMonitor.txtFLT_p(1) = Vfault_p
    frmFaultConfigMonitor.txtFLT_n(1) = Vfault_n
    For i = 0 To 8
        frmFaultConfigMonitor.txtFault(i) = Shift_Right(PGA308Registers(9) And (2 ^ i), i) 'was i^2 changed may 9
       ' MsgBox frmFaultConfigMonitor.txtFault(i)
    Next i
 
    
End If

'
'  end fault config monator -- Active_frmFaultConfigMonitor
'










'
'  fault offset ref config -- Active_frmCorOffsetConf
'
If Active_frmCorOffsetConf = True Then
    '
    ' optCorRef1 -- coarse offset
    '
    If (PGA308Registers(4) And (&HC00&)) = (&H0&) Then
        frmCorOffsetConf.optCorRef1 = True
        frmCorOffsetConf.optCorRef2 = False
        frmCorOffsetConf.optCorRef3 = False
        frmCorOffsetConf.optCorRef4 = False
        Vref_int = 1 / 2
    ElseIf (PGA308Registers(4) And (&HC00&)) = (&H400&) Then
        frmCorOffsetConf.optCorRef1 = False
        frmCorOffsetConf.optCorRef2 = True
        frmCorOffsetConf.optCorRef3 = False
        frmCorOffsetConf.optCorRef4 = False
        Vref_int = 1 / 3
    ElseIf (PGA308Registers(4) And (&HC00&)) = (&H800&) Then
        frmCorOffsetConf.optCorRef1 = False
        frmCorOffsetConf.optCorRef2 = False
        frmCorOffsetConf.optCorRef3 = True
        frmCorOffsetConf.optCorRef4 = False
        Vref_int = 1 / 4
    ElseIf (PGA308Registers(4) And (&HC00&)) = (&HC00&) Then
        frmCorOffsetConf.optCorRef1 = False
        frmCorOffsetConf.optCorRef2 = False
        frmCorOffsetConf.optCorRef3 = False
        frmCorOffsetConf.optCorRef4 = True
        Vref_int = 1 / 5
    End If
Else
    If (PGA308Registers(4) And (&HC00&)) = (&H0&) Then
        Vref_int = 1 / 2
    ElseIf (PGA308Registers(4) And (&HC00&)) = (&H400&) Then
        Vref_int = 1 / 3
    ElseIf (PGA308Registers(4) And (&HC00&)) = (&H800&) Then
        Vref_int = 1 / 4
    ElseIf (PGA308Registers(4) And (&HC00&)) = (&HC00&) Then
        Vref_int = 1 / 5
    End If
End If
'
'  end of fault offset ref config -- Active_frmCorOffsetConf
'

     
    
    '
    ' reset the corase offset bits
    '
    frmMain_PGA308.cmbCoarseOffset.Clear
    For i = 0 To &HFF&
        If (i And &H80&) = 0 Then
            Vcor = i * Vref_PGA308 * Vref_int * (2 * 4) / (195 * 41)
        Else
            Vcor = -(i And &H7F) * Vref_PGA308 * Vref_int * (2 * 4) / (195 * 41)
        End If
        frmMain_PGA308.cmbCoarseOffset.AddItem EuroFormat(Vcor * 1000, "0.0##") + "mV"
        Array_CoarseOffset(i) = Vcor
    Next i

    '
    'CoarseOffset
    '
    frmMain_PGA308.cmbCoarseOffset.ListIndex = PGA308Registers(2) And (&HFF&)




'
'  One-Wire config -- Active_frmOneWireConfig
'

If Active_frmOneWireConfig = True Then
    If (PGA308Registers(4) And (&H8000&)) = (&H8000&) Then
        frmOneWireConfig.chkOWD = 1
    Else
        frmOneWireConfig.chkOWD = 0
    End If
    If (PGA308Registers(4) And (&H4000&)) = (&H4000&) Then
        frmOneWireConfig.chkOWD_Off = 1
    Else
        frmOneWireConfig.chkOWD_Off = 0
    End If
    If (PGA308Registers(4) And (&H1000&)) = (&H1000&) Then
        frmOneWireConfig.chkNOW = 1
    Else
        frmOneWireConfig.chkNOW = 0
    End If
    If (PGA308Registers(4) And (&H2000&)) = (&H2000&) Then
        frmOneWireConfig.chkDisOUT = 1
    Else
        frmOneWireConfig.chkDisOUT = 0
    End If
    If (PGA308Registers(7) And (&H80&)) = (&H80&) Then
        frmOneWireConfig.chkOW_DLY = 1
    Else
        frmOneWireConfig.chkOW_DLY = 0
    End If
End If
'
'  One-Wire config -- Active_frmOneWireConfig
'


Updating_Controls = False
End Sub
Public Sub SetRegLegend()
  Dim i As Integer
  
' now setting the individual bit Labels
    RegBitLabel(0) = Array("ZD15", "ZD14", "ZD13", "ZD12", "ZD11", "ZD10", "ZD9", "ZD8", "ZD7", "ZD6", "ZD5", "ZD4", "ZD3", "ZD2", "ZD1", "ZD0")
    RegBitLabel(1) = Array("GD15", "GD14", "GD13", "GD12", "GD11", "GD10", "GD9", "GD8", "GD7", "GD6", "GD5", "GD4", "GD3", "GD2", "GD1", "GD0")
    RegBitLabel(2) = Array("G02", "G01", "G00", "GI4", "GI3", "GI2", "GI1", "GI0", "OS7", "OS6", "OS5", "OS4", "OS3", "OS2", "OS1", "OS0")
    RegBitLabel(3) = Array("FLT_REF", "FLT_IPU", "OU_CFG", "FLT_SEL", "CMP_SEL", "EXT_EN", "INT_EN", "EXT_POL", "INT_POL", "OU_EN", "HL2", "HL1", "HL0", "LL2", "LL1", "LL0")
    RegBitLabel(4) = Array("OWD", "OWD_OFF", "DIS_OUT", "NOW", "COS_VR1", "COS_VR0", "RFB", "DOUT_SEL", "DOUT", "SD", "RFB", "RFB", "RFB", "RFB", "RFB", "RFB")
    RegBitLabel(5) = Array("CK15", "CK14", "CK13", "CK12", "CK11", "CK10", "CK9", "CK8", "CK7", "CK6", "CK5", "CK4", "CK3", "CK2", "CK1", "CK10")
    RegBitLabel(6) = Array("CS15", "CS14", "CS13", "CS12", "CS11", "CS10", "CS9", "CS8", "CS7", "CS6", "CS5", "CS4", "CS3", "CS2", "CS1", "CS0")
    RegBitLabel(7) = Array("RFB", "RFB", "RFB", "RFB", "RFB", "RFB", "RFB", "CHKS_FLG", "OW_DLY", "SWL2", "SWL1", "SWL0", "RFB", "XP5", "XP4", "XP3")
    RegBitLabel(8) = Array("RFB", "RFB", "RFB", "RFB", "RFB", "RFB", "RFB", "RFB", "OEN7", "OEN6", "OEN5", "OEN4", "OEN3", "OEN2", "OEN1", "OEN0")
    RegBitLabel(9) = Array("X", "X", "X", "X", "X", "X", "X", "A1SAT_HI", "A1SAT_LO", "A2SAT_HI", "A2SAT_LO", "A3SAT_LO", "INN_HI", "INN_LO", "INP_HI", "INP_LO")
    RegBitLabel(10) = Array("OTP_EN", "ERR_FLG", "COR_FLG", "OTP_BSY", "OTP_MW", "RFB", "RFB", "RFB", "RFB", "RFB", "RFB", "RFB", "RFB", "RFB", "RFB", "RFB")
    RegBitLabel(11) = Array("FRB15", "FRB14", "FRB13", "FRB12", "FRB11", "FRB10", "FRB9", "FRB8", "FRB7", "FRB6", "FRB5", "FRB4", "FRB3", "FRB2", "FRB1", "FRB0")
    RegBitLabel(12) = Array("FRB15", "FRB14", "FRB13", "FRB12", "FRB11", "FRB10", "FRB9", "FRB8", "FRB7", "FRB6", "FRB5", "FRB4", "FRB3", "FRB2", "FRB1", "FRB0")
    RegBitLabel(13) = Array("OTP5", "OTP4", "OTP3", "OTP2", "OTP1", "OTP0", "TM3", "TM2", "TM2", "TM0", "FUS1", "FUS0", "TBD", "TBD", "TBD", "TBD")
    RegBitLabel(14) = Array("TBD", "TBD", "TBD", "TBD", "TBD", "TBD", "TBD", "TBD", "TBD", "OTC_STS", "OSC_ST5", "OSC_ST4", "OSC_ST3", "OSC_ST2", "OSC_ST1", "OSC_ST0")
    RegBitLabel(15) = Array("BWO12", "BWO11", "BWO10", "BWO9", "BWO8", "BWO7", "BWO6", "BWO5", "BWO4", "BWO3", "BWO2", "BWO1", "BWO0", "RFB", "WPL", "WNL")
    
    
 Reg_ReadOnly(0) = False
 Reg_ReadOnly(1) = False
 Reg_ReadOnly(2) = False
 Reg_ReadOnly(3) = False
 Reg_ReadOnly(4) = False
 Reg_ReadOnly(5) = False
 Reg_ReadOnly(6) = True 'Jul 14, 08
 Reg_ReadOnly(7) = False
 Reg_ReadOnly(8) = False
 Reg_ReadOnly(9) = True 'Jul 14, 08
 Reg_ReadOnly(10) = False
 Reg_ReadOnly(11) = False
 Reg_ReadOnly(12) = False
 Reg_ReadOnly(13) = False
 Reg_ReadOnly(14) = False
 Reg_ReadOnly(15) = False
 Reg_ReadOnly(16) = False
 Reg_ReadOnly(17) = False
 Reg_ReadOnly(18) = False
 Reg_ReadOnly(19) = False
 Reg_ReadOnly(20) = False
 Reg_ReadOnly(21) = False
 Reg_ReadOnly(22) = False
 Reg_ReadOnly(23) = True 'NOT USED
 Reg_ReadOnly(24) = False
 Reg_ReadOnly(25) = True
 Reg_ReadOnly(26) = True
 Reg_ReadOnly(27) = True
End Sub



Public Sub UpdateRegisterDisplay()
    Dim i As Integer    ' loop index
  With frmMain_PGA308.gridReg
    If (.TextMatrix(1, 0) <> "00h") Then  'if running for the first time
                                    ' fill out the info columns
        .TextMatrix(1, 0) = "00h"
        .TextMatrix(1, 1) = " Zdac"
        .TextMatrix(2, 0) = "01h"
        .TextMatrix(2, 1) = " Gdac"
        .TextMatrix(3, 0) = "02h"
        .TextMatrix(3, 1) = " CFG0"
        .TextMatrix(4, 0) = "03h"
        .TextMatrix(4, 1) = " CFG1"
        .TextMatrix(5, 0) = "04h"
        .TextMatrix(5, 1) = " CFG2"
        .TextMatrix(6, 0) = "05h"
        .TextMatrix(6, 1) = " CHKS"
        .TextMatrix(7, 0) = "06h"
        .TextMatrix(7, 1) = " CHSR"
        .TextMatrix(8, 0) = "07h"
        .TextMatrix(8, 1) = " SFTC"
        .TextMatrix(9, 0) = "08h"
        .TextMatrix(9, 1) = " OENC"
        .TextMatrix(10, 0) = "09h"
        .TextMatrix(10, 1) = " ALRM"
        .TextMatrix(11, 0) = "0Ah"
        .TextMatrix(11, 1) = " OTPS"
        If Engineering_Mode = 1 Then
            .TextMatrix(12, 0) = "0Bh"
            .TextMatrix(12, 1) = " ---- "
            .TextMatrix(13, 0) = "0Ch"
            .TextMatrix(13, 1) = " ---- "
            .TextMatrix(14, 0) = "0Dh"
            .TextMatrix(14, 1) = " TST"
            .TextMatrix(15, 0) = "0Eh"
            .TextMatrix(15, 1) = " BDCL"
            .TextMatrix(16, 0) = "0Fh"
            .TextMatrix(16, 1) = " TRST"
        End If
   End If
    'If UpdateFlag And (frmMain_PGA308.chkAutoSum = 1) Then
                'if checksum update is allowed
        'Call CalcCheckSumRegisters
    'End If
    For i = 0 To MaxReg
        If OldReg(i) <> PGA308Registers(i) Then
            MarkRegForWrite(i) = True
        End If
        If MarkRegForWrite(i) = True Then
            .TextMatrix(i + 1, 1) = " *** " + TestNames(i + 1) + " *** "
        End If
    Next i
    
    For i = 0 To MaxReg
         OldReg(i) = PGA308Registers(i)
    Next i
    
    For i = 0 To MaxReg
        .TextMatrix(i + 1, 2) = "0x" & RegVal2Str(PGA308Registers(i), 1, False)
        .TextMatrix(i + 1, 3) = "0x" & RegVal2Str(PGA308Registers(i), 0, False)
    Next i
  '  For i = 0 To MaxReg
   '     Select Case i
       'Case 2, MaxReg     'skip -- no analog equ
   '     Case Else
        'Call UpdateDecimal(i)
        '.TextMatrix(i + 1, 4) = Decmal209_Register(i)
   '     End Select
  '  Next i
  End With
  Call frmMain_PGA308.ShowRegDetails       ' update those
  Call Update_Controls 'update controls based on reg values

 'Updating_Controls = True

 
 

 'Updating_Controls = False


End Sub
Public Sub UpdateOTP_RegisterDisplay(Optional UpdateFlag As Boolean = True)
    Dim i As Integer    ' loop index
  With frmMain_PGA308.fgrid_OTP
    If .TextMatrix(1, 0) <> "00h" Then 'if running for the first time
                                    ' fill out the info columns
        .TextMatrix(1, 0) = "ZDAC"
        .TextMatrix(2, 0) = "GDAC"
        .TextMatrix(3, 0) = "CFG0"
        .TextMatrix(4, 0) = "CFG1"
        .TextMatrix(5, 0) = "CFG2"
        .TextMatrix(6, 0) = "CHKS"
        .TextMatrix(7, 0) = "USER1"
        .TextMatrix(8, 0) = "USER2"
   End If
End With

End Sub

Public Sub UpdateRAM_RegisterDisplay(Optional UpdateFlag As Boolean = True)
    Dim i As Integer    ' loop index
  With frmMain_PGA308.fgrid_RAM
    If .TextMatrix(1, 0) <> "00h" Then 'if running for the first time
                                    ' fill out the info columns
        .TextMatrix(1, 0) = "ZDAC"
        .TextMatrix(2, 0) = "GDAC"
        .TextMatrix(3, 0) = "CFG0"
        .TextMatrix(4, 0) = "CFG1"
        .TextMatrix(5, 0) = "CFG2"
        .TextMatrix(6, 0) = "CHKS"
        '.TextMatrix(7, 0) = "USER1"
        '.TextMatrix(8, 0) = "USER2"
   End If
End With

End Sub

Public Sub UpdateDecimal(RegNumber)

'eliminated 7/31/07


'Select Case RegNumber
'Case 0
'    Decmal209_Register(RegNumber) = (Vref_PGA308 / 2) - (PGA308Registers(RegNumber) * Vref_PGA308 / 65536)
'Case 1
'    Decmal209_Register(RegNumber) = (2 / 3) * PGA308Registers(RegNumber) / &HFFFF& + (1 / 3)
'Case 5, &HB&, &HE&, &H11&
'    Decmal209_Register(RegNumber) = PGA308Registers(RegNumber) * PowerLSB
'Case 6
'    If (PGA308Registers(RegNumber) And (&H8000&)) = 0 Then
'        Decmal209_Register(RegNumber) = PGA308Registers(RegNumber)
'    Else
'        Decmal209_Register(RegNumber) = -(&H8000& - (PGA308Registers(RegNumber) And &H7FFF&))
'    End If
'    Decmal209_Register(RegNumber) = Decmal209_Register(RegNumber) * CurrentLSB
'Case &H14&   'critical dac+
'    Decmal209_Register(RegNumber) = Int(PGA308Registers(RegNumber) / (2 ^ 8))
'    Decmal209_Register(RegNumber) = Decmal209_Register(RegNumber) * 0.001
'Case &H15&  'critical dac-
'    Decmal209_Register(RegNumber) = Int(PGA308Registers(RegNumber) / (2 ^ 8))
 '   Decmal209_Register(RegNumber) = -Decmal209_Register(RegNumber) * 0.001
'End Select

End Sub
Public Function convert_string_to_hex16(input_string, error_flag As Boolean) As Integer
If Len(input_string) > 4 Or Len(input_string) <= 0 Then
        MsgBox "error in convert_string_to_hex16 string too long"
        convert_string_to_hex16 = 0
        error_flag = True
        Exit Function
End If

For ii = 1 To Len(input_string)
    ca = Asc(Mid(input_string, ii, 1))
    no_error1 = 0
    If ((ca >= 48) And (ca <= 57)) Or ((ca >= 65) And (ca <= 70)) Or ((ca >= 97) And (ca <= 102)) Then
        'input string a to f, A to F, or 0 to 9
        error_flag = False
    Else
        MsgBox "error in convert_string_to_hex16 non hex char"
        convert_string_to_hex16 = 0
        error_flag = True
        Exit Function
    End If
Next ii
convert_string_to_hex16 = "&H" + input_string
End Function

Public Function RegVal2Str(Inval As Long, Frmt As Integer, TwosComp As Boolean) As String
        ' inVal is the input number
        ' Frmt is the output format: 0 - binary, 1 - hex (4symbols), 2 - decimal
        ' TwosComp - 2's compliment flag, True/False
    Dim AdjVal As Long
    If TwosComp And (Inval < 0) Then    'processing 2's compliment value
        AdjVal = Inval + 65536
    Else
        AdjVal = Inval
    End If
    If (AdjVal < 0) Or (AdjVal > 65535) Then ' return empty str if input is out of limits
        RegVal2Str = ""
        Exit Function
    End If
    Select Case Frmt
    Case 0  ' binary
        RegVal2Str = Display16Bit(AdjVal)
    Case 1  ' hex
        RegVal2Str = Hex(AdjVal)    ' changed from euroformat(Hex(AdjVal), "0000")
        Do While Len(RegVal2Str) < 4
                ' add leading zeros
            RegVal2Str = "0" & RegVal2Str
        Loop
    Case 2 ' decimal (note: no 2's compliment in this case)
        RegVal2Str = EuroFormat(CStr(Inval), "#####0")
    End Select
End Function

Public Function Display16Bit(Inval As Long) As String
    Display16Bit = DisplayBinary(Inval)
    If Len(Display16Bit) > 16 Then
        Display16Bit = Right(Display16Bit, 16)
    Else
        While Len(Display16Bit) < 16
'            If ((Len(Display16Bit) Mod 4) = 0) Then Display16Bit = "_" & Display16Bit
            Display16Bit = "0" & Display16Bit
        Wend
    End If
    Display16Bit = Mid(Display16Bit, 1, 4) & "_" _
                 & Mid(Display16Bit, 5, 4) & "_" _
                 & Mid(Display16Bit, 9, 4) & "_" _
                 & Mid(Display16Bit, 13, 4)
End Function
Public Function DisplayBinary(Inval As Long) As String
    If Inval = 0 Then
        DisplayBinary = 0
    Else
        DisplayBinary = DisplayBinary(Fix(Inval / 2#)) & EuroFormat(Inval Mod 2, "0")
    End If
End Function


Public Sub Write_OTP_6_7()
Dim X As Integer
Dim chk_flag As Boolean

If ((PGA308Registers(10) And &H8000&) <> &H8000&) Then
    MsgBox "OTP is not 'Enabled for Write'.  (Register 10, Bit 15, OTP_EN)" + vbCrLf + "The PGA308 software will set this automatically."
    PGA308Registers(10) = PGA308Registers(10) Or &H8000&
End If
'If (PGA308Registers(5) <> PGA308Registers(6)) Then
'    MsgBox "The check sum you are using is not correct.  Copy register 6 into register 5 for correct check sum." + vbCrLf + "The PGA308 software will set this automatically."
'    Exit Sub
'End If

'
' write OTP_EN =1
'
        REG_MSB = Shift_Right((&HFF00&) And (PGA308Registers(10)), 8)
        REG_LSB = (&HFF&) And (PGA308Registers(10))
        Call RunMnemonicCommand("ONE 55 " + Hex(10) + " " + Hex(REG_LSB) + " " + Hex(REG_MSB)) 'write
        If ReadData(30) <> 0 Then
            MsgBox "timeout on One-Wire transaction"
        End If
'
' DONE write OTP_EN =1
'

Bank_No = OTP_Bank_Pointer
For Reg_No = 6 To 7
    Bank_Pointer = Shift_Left(Bank_No, 3)
    Read_notWrite = &H0&  'read = &H80&, write = &H00&
    Bank_notSoftware = &H40& 'B/notR = &H40& for bank, B/notR = &H00& for software
    OTP_Address = Bank_notSoftware Or Read_notWrite Or Bank_Pointer Or Reg_No
    X = convert_string_to_hex16(frmMain_PGA308.txtUSER(Reg_No - 6), chk_flag)
    frmMain_PGA308.txtUSER(Reg_No - 6).Text = Hex(X)
    If chk_flag = False Then
        REG_MSB = Shift_Right((&HFF00&) And (X), 8)
        REG_LSB = (&HFF&) And (X)
        Call RunMnemonicCommand("ONE 55 " + Hex(OTP_Address) + " " + Hex(REG_LSB) + " " + Hex(REG_MSB)) 'set pointer
    End If
Next Reg_No

End Sub

Public Sub WritePGA_InputV(Vdif_pga, Vcm_pga)
Vdif1 = -Vdif_pga
'Dim VdacB, VdacC
If Vdif1 > 0 Then
    VdacB = Vdif1 * 100 + 0.1
    VdacC = 0.1
Else
    VdacB = 0.1
    VdacC = -Vdif1 * 100 + 0.1
End If
Call Write_DAC_B(VdacB, ads_Conf, 1)
   frmMain_PGA308.ProgressBar1.value = 25

Call Write_DAC_C(VdacC, ads_Conf, 1)
   frmMain_PGA308.ProgressBar1.value = 50

Call Write_DAC_A(Vcm_pga, ads_Conf, 1)
   frmMain_PGA308.ProgressBar1.value = 75

Call pause(1)

End Sub


Public Sub FastWritePGA_InputV(Vdif_pga, Vcm_pga)
Vdif1 = -Vdif_pga
'Dim VdacB, VdacC
If Vdif1 > 0 Then
    VdacB = Vdif1 * 100 + 0.1
    VdacC = 0.1
Else
    VdacB = 0.1
    VdacC = -Vdif1 * 100 + 0.1
End If
Call Write_DAC_B(VdacB, ads_Conf, 0)
'   frmMain_PGA308.ProgressBar1.value = 25

Call Write_DAC_C(VdacC, ads_Conf, 0)
'   frmMain_PGA308.ProgressBar1.value = 50

 Call Write_DAC_A(Vcm_pga, ads_Conf, 0)
'   frmMain_PGA308.ProgressBar1.value = 75


End Sub



