VERSION 5.00
Begin VB.Form frmOneWireConfig 
   Caption         =   "One Wire Control"
   ClientHeight    =   8205
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   8115
   LinkTopic       =   "Form1"
   ScaleHeight     =   8205
   ScaleWidth      =   8115
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame frmOne 
      Caption         =   "One-Wire and Output Config"
      Height          =   7815
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   7815
      Begin VB.CheckBox chkOW_DLY 
         Caption         =   "OW_DLY"
         Height          =   495
         Left            =   360
         TabIndex        =   11
         Top             =   6840
         Width           =   1095
      End
      Begin VB.CheckBox chkOneToVout 
         Caption         =   "One Wire Connected to Vout"
         Height          =   615
         Left            =   360
         TabIndex        =   9
         Top             =   5640
         Width           =   1095
      End
      Begin VB.CheckBox chkDisOUT 
         Caption         =   "Dis Out"
         Height          =   255
         Left            =   360
         TabIndex        =   7
         Top             =   4680
         Width           =   975
      End
      Begin VB.CheckBox chkNOW 
         Caption         =   "NOW"
         Height          =   255
         Left            =   360
         TabIndex        =   5
         Top             =   3240
         Width           =   855
      End
      Begin VB.CheckBox chkOWD_Off 
         Caption         =   "OWD OFF"
         Height          =   255
         Left            =   360
         TabIndex        =   3
         Top             =   1920
         Width           =   1095
      End
      Begin VB.CheckBox chkOWD 
         Caption         =   "OWD "
         Height          =   255
         Left            =   360
         TabIndex        =   1
         Top             =   600
         Width           =   735
      End
      Begin VB.Label lblOW_DLY 
         AutoSize        =   -1  'True
         Caption         =   "Label1"
         Height          =   195
         Left            =   1800
         TabIndex        =   12
         Top             =   6960
         Width           =   5295
         WordWrap        =   -1  'True
      End
      Begin VB.Label lblCycPowOnOne 
         AutoSize        =   -1  'True
         Caption         =   "Label1"
         Height          =   195
         Left            =   1800
         TabIndex        =   10
         Top             =   5640
         Width           =   5295
         WordWrap        =   -1  'True
      End
      Begin VB.Label lblDisOut 
         AutoSize        =   -1  'True
         Caption         =   "Label1"
         Height          =   195
         Left            =   1800
         TabIndex        =   8
         Top             =   4680
         Width           =   5295
         WordWrap        =   -1  'True
      End
      Begin VB.Label lblNow 
         AutoSize        =   -1  'True
         Caption         =   "Label1"
         Height          =   195
         Left            =   1800
         TabIndex        =   6
         Top             =   3240
         Width           =   5295
         WordWrap        =   -1  'True
      End
      Begin VB.Label lblOWD_OFF 
         AutoSize        =   -1  'True
         Caption         =   "Label1"
         Height          =   195
         Left            =   1800
         TabIndex        =   4
         Top             =   1920
         Width           =   5295
         WordWrap        =   -1  'True
      End
      Begin VB.Label lblOWD 
         AutoSize        =   -1  'True
         Caption         =   "Label1"
         Height          =   195
         Left            =   1800
         TabIndex        =   2
         Top             =   600
         Width           =   5295
         WordWrap        =   -1  'True
      End
   End
End
Attribute VB_Name = "frmOneWireConfig"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub Check1_Click()
End Sub

Private Sub chkDisOUT_Click()
Call Read_Controls

End Sub

Private Sub chkNOW_Click()
Call Read_Controls

End Sub

Private Sub chkOneToVout_Click()
If chkOneToVout.value = 1 Then
        OneWire_to_Vout = True
        frmMain_PGA308.line_one_wire.Visible = True
    Else
        OneWire_to_Vout = False
        frmMain_PGA308.line_one_wire.Visible = False
End If
Call set_RAM_OTP_Modes
End Sub

Private Sub chkOW_DLY_Click()
Call Read_Controls

End Sub

Private Sub chkOWD_Click()
Call Read_Controls

End Sub

Private Sub chkOWD_Off_Click()
Call Read_Controls

End Sub

Private Sub Form_Load()
Active_frmOneWireConfig = True
lblOWD = "When this bit is enabled, the One-Wire will only be active for 25mS after power up. "
lblOWD = lblOWD + "This option is used when One-Wire is tied to Vout.  With OWD enabled the communications can only occur after power-up."
lblOWD = lblOWD + "This option prevents PGA output signals from being erroneously interpreted as a One-Wire signal."
lblOWD = lblOWD + "When this bit is not enabled, the One-Wire interfaces is always active (unless OWD OFF is set)."

lblOWD_OFF = "When this bit is enabled, the One-Wire will only be immediately disabled. "
lblOWD_OFF = lblOWD_OFF + "If the OWD OFF bit is written into the OTP power-on default, then the One-Wire interface will be permanently disabled."
lblOWD_OFF = lblOWD_OFF + "This feature may be used after the PGA has been programed to protect if from any future read or writes."

lblNow = "When this bit is enabled, the output will be enabled immediately after the OTP has been read (short 50uS delay). "
lblNow = lblNow + "This feature should only be used if the One-Wire pin is not connected to the output."
lblNow = lblNow + "When this bit is not enabled, the output will go into a high impedance state for 25mS after power-up."

lblDisOut = "When this bit is enabled, the analog output is in high impedance mode. "

lblCycPowOnOne = "This is an evaluation module feature that allows the 1W pin to be connected to Vout.  When enabled,  "
lblCycPowOnOne = lblCycPowOnOne + "power will be cycled before each One-Wire communicaiton.  Cycling power places the output in"
lblCycPowOnOne = lblCycPowOnOne + "high impedance mode during initial communication."


lblOW_DLY = "One-Wire Delay.  1=9 bit delay from Transmit to Receive during One-Wire Reads."
lblOW_DLY = lblOW_DLY + "   0=1 bit delay from Transmit to Receive during One-Wire Reads."

Call Update_Controls

If OneWire_to_Vout = True Then
    chkOneToVout.value = 1
Else
    chkOneToVout.value = 0
End If
End Sub

Private Sub Form_Unload(Cancel As Integer)

If Current_Output = False Then
    If OneWire_to_Vout = True Then
        frmMain_PGA308.cmbOutputMode.ListIndex = 1
        frmPre_Post_Cal_Preset.cmbOutputMode.ListIndex = 1
    Else
        frmMain_PGA308.cmbOutputMode.ListIndex = 0
        frmPre_Post_Cal_Preset.cmbOutputMode.ListIndex = 0
    End If
Else
        frmMain_PGA308.cmbOutputMode.ListIndex = 2
        frmPre_Post_Cal_Preset.cmbOutputMode.ListIndex = 2
End If
Active_frmOneWireConfig = False

End Sub

