VERSION 5.00
Begin VB.Form frmPortSettings 
   Caption         =   "COM Port Setup"
   ClientHeight    =   3270
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   2700
   LinkTopic       =   "Form2"
   MaxButton       =   0   'False
   ScaleHeight     =   3270
   ScaleWidth      =   2700
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   120
      TabIndex        =   3
      Top             =   2640
      Width           =   1095
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Left            =   1320
      TabIndex        =   2
      Top             =   1680
      Width           =   1095
   End
   Begin VB.Frame frmCommPort 
      Caption         =   "Select Serial Port"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1455
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2295
      Begin VB.ComboBox comboBitRate 
         Height          =   315
         Left            =   1080
         Style           =   2  'Dropdown List
         TabIndex        =   6
         Top             =   840
         Width           =   1092
      End
      Begin VB.ComboBox comboComPort 
         Height          =   315
         Left            =   1080
         Style           =   2  'Dropdown List
         TabIndex        =   1
         Top             =   360
         Width           =   1092
      End
      Begin VB.Label txtstatusLabel 
         Height          =   855
         Left            =   2280
         TabIndex        =   7
         Top             =   240
         Width           =   1095
      End
      Begin VB.Label Label2 
         Caption         =   "Baud Rate:"
         Height          =   255
         Left            =   120
         TabIndex        =   5
         Top             =   840
         Width           =   975
      End
      Begin VB.Label Label1 
         Caption         =   "Port # :"
         Height          =   255
         Left            =   120
         TabIndex        =   4
         Top             =   360
         Width           =   735
      End
   End
End
Attribute VB_Name = "frmPortSettings"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'Enables users to select a parallel or serial port and bit rate.
Dim NewTalkMode As Integer
'Dim NewLPTAddr As Integer
Dim NewSerPort As Integer
Dim NewBitRate As Long

Private Sub Form_Load()
    Dim Count As Integer
  '  NewTalkMode = TalkMode
  '  If NewTalkMode = 0 Then
  '      optI2C.Value = True
  '  Else
  '      opt1Wire = True
  '  End If
'    NewLPTAddr = Port_Data
'    NewSerPort = PortNumber
'    NewBitRate = BitRate
'    Call FindPorts
    'Set default values if a retrieved setting is invalid.
    'Be sure the selected port exists.
    If Bitrate = 0 Then
        Bitrate = 9600
    End If
    Call InitializePortComboBox
    Call InitializeBitRateComboBox
End Sub

Private Sub InitializeBitRateComboBox()
Dim i As Integer
With comboBitRate
    .AddItem "4800", 0
    .AddItem "9600", 1
    .AddItem "19200", 2
' comment on 28.12.2003 -
' couldn't make 28.8 and 38.4 to work for some reason
' worked fine on 13.01 - enabled back??
    .AddItem "28800", 3
    .AddItem "38400", 4
    .ListIndex = -1
    For i = 0 To .ListCount - 1
        If Bitrate = Val(.List(i)) Then
            .ListIndex = i
        End If
    Next i
End With
End Sub
Private Sub InitializePortComboBox()
    Dim Count As Integer
    PortExists = False
    For Count = 1 To 32 'UBound(CommPorts())
        comboComPort.AddItem CommPorts(Count)
        If "COM" & CStr(PortNumber) = CommPorts(Count) Then
            PortExists = True
            comboComPort.ListIndex = Count - 1 '-1 because the 1st port is COM1
        End If
    Next Count
    'Display the Setup window if the retrieved port number is invalid,
    'or if the port is unavailable.
    If PortNumber < 1 Then
        comboComPort.ListIndex = -1
        txtstatusLabel.Caption = "Please select a COM port."
    End If
    If PortExists = False Then
        comboComPort.ListIndex = -1
        txtstatusLabel.Caption = "COM" & PortNumber & " is unavailable. Please select a different port."
    End If
End Sub

Private Sub comboBitRate_Click()
    Bitrate = CLng(comboBitRate.List(comboBitRate.ListIndex))
    Call SerStartup
End Sub
Private Sub comboComPort_Click()
    If comboComPort.ListIndex >= 0 Then
        'if the index is valid (not =-1)
      PortNumber = Right(comboComPort.List(comboComPort.ListIndex), 1)
      Call SerStartup
    End If
End Sub

Private Sub cmdOK_Click()
'The application's main form reads the new settings.
    Call cmdDetectBench_Click
    Unload Me
End Sub

Private Sub cmdDetectBench_Click()
'    BitRate = Val(comboBitRate.Text)
'    PortNumber = Val(Right(comboComPort.Text, 1))
   ' If NewTalkMode = 0 Then
  '      frmmain_pga308.optI2C.Value = True
   ' Else
  '      frmmain_pga308.opt1Wire.Value = True
  '  End If      ' the procedures in frmmain_pga308 will take care of
                ' setting the new TalkMode and initialize the ports
  '  Call frmmain_pga308.mnuBenchDetect_Click
End Sub

Private Sub opt1wire_Click()
    NewTalkMode = 1
End Sub

Private Sub optI2C_Click()
    NewTalkMode = 0
End Sub

Private Sub cmdCancel_Click()
'    frmPortSettings.Hide
    Unload Me
End Sub

