VERSION 5.00
Begin VB.Form frmSerialPort 
   Caption         =   "Select and Configure COM Port"
   ClientHeight    =   4740
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   3780
   LinkTopic       =   "Form1"
   ScaleHeight     =   4740
   ScaleWidth      =   3780
   StartUpPosition =   3  'Windows Default
   Begin VB.Frame frmCommPort 
      Caption         =   "Select Serial Port"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   3615
      Left            =   360
      TabIndex        =   2
      Top             =   240
      Width           =   3135
      Begin VB.ComboBox cmbFlow 
         Height          =   315
         Left            =   1200
         Style           =   2  'Dropdown List
         TabIndex        =   14
         Top             =   3120
         Width           =   1575
      End
      Begin VB.ComboBox cmbParity 
         Height          =   315
         Left            =   1200
         Style           =   2  'Dropdown List
         TabIndex        =   13
         Top             =   2016
         Width           =   1575
      End
      Begin VB.ComboBox cmbStopBit 
         Height          =   315
         Left            =   1200
         Style           =   2  'Dropdown List
         TabIndex        =   10
         Top             =   2568
         Width           =   1575
      End
      Begin VB.ComboBox cmbDataBits 
         Height          =   315
         Left            =   1200
         Style           =   2  'Dropdown List
         TabIndex        =   9
         Top             =   1464
         Width           =   1575
      End
      Begin VB.ComboBox comboComPort 
         Height          =   315
         Left            =   1200
         Style           =   2  'Dropdown List
         TabIndex        =   4
         Top             =   360
         Width           =   1575
      End
      Begin VB.ComboBox comboBitRate 
         Height          =   315
         Left            =   1200
         Style           =   2  'Dropdown List
         TabIndex        =   3
         Top             =   912
         Width           =   1575
      End
      Begin VB.Label Label6 
         Caption         =   "Flow Control"
         Height          =   375
         Left            =   240
         TabIndex        =   12
         Top             =   3120
         Width           =   855
      End
      Begin VB.Label Label5 
         Caption         =   "Parity"
         Height          =   255
         Left            =   240
         TabIndex        =   11
         Top             =   2016
         Width           =   615
      End
      Begin VB.Label Label4 
         Caption         =   "Stop Bit"
         Height          =   255
         Left            =   240
         TabIndex        =   8
         Top             =   2568
         Width           =   615
      End
      Begin VB.Label Label3 
         Caption         =   "Data Bits"
         Height          =   255
         Left            =   240
         TabIndex        =   7
         Top             =   1464
         Width           =   735
      End
      Begin VB.Label Label1 
         Caption         =   "Port # :"
         Height          =   255
         Left            =   240
         TabIndex        =   6
         Top             =   360
         Width           =   735
      End
      Begin VB.Label Label2 
         Caption         =   "Baud Rate:"
         Height          =   255
         Left            =   240
         TabIndex        =   5
         Top             =   912
         Width           =   975
      End
   End
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   495
      Left            =   2400
      TabIndex        =   1
      Top             =   4080
      Width           =   1095
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   495
      Left            =   240
      TabIndex        =   0
      Top             =   4080
      Width           =   1095
   End
End
Attribute VB_Name = "frmSerialPort"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Sub cmbDataBits_Click()
    If cmbDataBits.ListIndex >= 0 Then
        'if the index is valid (not =-1)
      Numb_Data_Bits = cmbDataBits.List(cmbDataBits.ListIndex)
       
    End If

End Sub

Private Sub cmbFlow_Click()
    If cmbFlow.ListIndex >= 0 Then
        'if the index is valid (not =-1)
      Flow_Control = cmbFlow.ListIndex
       
    End If


End Sub

Private Sub cmbParity_Click()
    If cmbDataBits.ListIndex >= 0 Then
        'if the index is valid (not =-1)
      Parity = Left(cmbParity.List(cmbParity.ListIndex), 1)
       
    End If


End Sub

Private Sub cmbStopBit_Click()
    If cmbStopBit.ListIndex >= 0 Then
        'if the index is valid (not =-1)
      Numb_Stop_Bits = cmbStopBit.List(cmbStopBit.ListIndex)
       
    End If


End Sub

Private Sub Form_Load()

    'If PortNumber = 0 Then
    '    PortNumber = 1
    'End If

    'If Bitrate = "" Then
    '    Bitrate = "9600"
    'End If
    
    Call InitializePortComboBox
    Call InitializeBitRateComboBox
    Call initDataBits
    Call initParity
    Call initStopBits
    Call initFlowControl
 
End Sub
Private Sub InitializeBitRateComboBox()
Dim i As Integer
With comboBitRate
    .AddItem "4800", 0
    .AddItem "9600", 1
    .AddItem "19200", 2
' comment on 28.12.2003 -
' couldn't make 28.8 and 38.4 to work for some reason
' worked fine on 13.01 - enabled back??
    .AddItem "28800", 3
    .AddItem "38400", 4
    .ListIndex = -1
    For i = 0 To .ListCount - 1
        If Bitrate = Val(.List(i)) Then
            .ListIndex = i
        End If
    Next i
End With
End Sub
Private Sub initDataBits()

With cmbDataBits
    .AddItem "5", 0
    .AddItem "6", 1
    .AddItem "7", 2
    .AddItem "8", 3
    'PortNumber, Bitrate, Parity, Numb_Data_Bits, Numb_Stop_Bits, Flow_Control
    For i = 0 To .ListCount - 1
        If Numb_Data_Bits = (.List(i)) Then 'sep 11 09
            .ListIndex = i
        End If
    Next i

End With
End Sub
Private Sub initFlowControl()

With cmbFlow
    .AddItem "None", 0
    .AddItem "Xon/Xoff", 1
    .AddItem "Hardware (RTS/CTS)", 2
    .AddItem "com RTS XOn XOff", 3
    'PortNumber, Bitrate, Parity, Numb_Data_Bits, Numb_Stop_Bits, Flow_Control
    For i = 0 To .ListCount - 1
        If Flow_Control = i Then
            .ListIndex = i
        End If
    Next i

End With
End Sub
Private Sub initParity()

With cmbParity
    .AddItem "None", 0
    .AddItem "Odd", 1
    .AddItem "Even", 2
    .AddItem "Mark", 3
    .AddItem "Space", 4
        'PortNumber, Bitrate, Parity, Numb_Data_Bits, Numb_Stop_Bits, Flow_Control
    For i = 0 To .ListCount - 1
        If Parity = Left((.List(i)), 1) Then
            .ListIndex = i
        End If
    Next i

End With

End Sub
Private Sub initStopBits()

With cmbStopBit
    .AddItem "1", 0
    .AddItem "1.5", 1
    .AddItem "2", 2
        'PortNumber, Bitrate, Parity, Numb_Data_Bits, Numb_Stop_Bits, Flow_Control
    For i = 0 To .ListCount - 1
        If Numb_Stop_Bits = Val(.List(i)) Then
            .ListIndex = i
        End If
    Next i
End With

End Sub

Private Sub InitializePortComboBox()
    Dim Count As Integer
    PortExists = False
On Error Resume Next
For Count = 1 To 16
    frmMain_PGA308.MSComm1.CommPort = Count
    frmMain_PGA308.MSComm1.PortOpen = True
    If Err.Number = 8005 Then
        'The port is already open
        'The port exists, so add it to the list.
        NumberOfPorts = NumberOfPorts + 1
        CommPorts(NumberOfPorts) = "COM" & CStr(Count)
        If SavedPortNumber = Count Then
            frmMain_PGA308.MSComm1.PortOpen = False
        End If
    ElseIf frmMain_PGA308.MSComm1.PortOpen = True Then
        'If the port opens, it exists.
        'Close it and add to the list.
        frmMain_PGA308.MSComm1.PortOpen = False
        NumberOfPorts = NumberOfPorts + 1
        CommPorts(NumberOfPorts) = "COM" & CStr(Count)
    End If
    Err.Clear
Next Count

    For Count = 1 To UBound(CommPorts())
        comboComPort.AddItem CommPorts(Count)
        If "COM" & CStr(PortNumber) = CommPorts(Count) Then
            PortExists = True
            comboComPort.ListIndex = Count - 1 '-1 because the 1st port is COM1
        End If
    Next Count
    'Display the Setup window if the retrieved port number is invalid,
    'or if the port is unavailable.
    If PortNumber < 1 Then
        comboComPort.ListIndex = -1
        txtstatusLabel.Caption = "Please select a COM port."
    End If
    If PortExists = False Then
        comboComPort.ListIndex = -1
        txtstatusLabel.Caption = "COM" & PortNumber & " is unavailable. Please select a different port."
    End If
End Sub

Private Sub comboBitRate_Click()
    Bitrate = (comboBitRate.List(comboBitRate.ListIndex))
    'Call SerOpen1(PortNumber, Bitrate)
End Sub
Private Sub comboComPort_Click()
    If comboComPort.ListIndex >= 0 Then
        'if the index is valid (not =-1)
      com_port_txt = comboComPort.List(comboComPort.ListIndex)
      PortNumber = Right(com_port_txt, Len(com_port_txt) - 3)
       
    End If
End Sub

Private Sub cmdOK_Click()
 Call SerOpen1(PortNumber, Bitrate, Parity, Numb_Data_Bits, Numb_Stop_Bits, Flow_Control)
    Unload Me
End Sub

Private Sub cmdDetectBench_Click()
'    BitRate = Val(comboBitRate.Text)
'    PortNumber = Val(Right(comboComPort.Text, 1))
   ' If NewTalkMode = 0 Then
  '      frmmain_pga308.optI2C.Value = True
   ' Else
  '      frmmain_pga308.opt1Wire.Value = True
  '  End If      ' the procedures in frmmain_pga308 will take care of
                ' setting the new TalkMode and initialize the ports
  '  Call frmmain_pga308.mnuBenchDetect_Click
End Sub


Private Sub cmdCancel_Click()
'    frmPortSettings.Hide
    Unload Me
End Sub
